obj/nuke_effect
	icon = 'Nuke thing.dmi'
	icon_state = "start"
	layer = 1.#INF
mob/Admin/verb
	Check_Runtimes()
		set category = "Admin"
		var/INFO = "<xmp>"
		INFO += file2text("RUNTIMES.txt")
		INFO += "</xmp>"
		src<<browse(INFO,"window=runtimes")
	Wipe_Runtimes()
		set category = "Admin"
		del file("RUNTIMES.txt")
	Nuke()
		set category = "Admin"
		set name = "End the Round"
		var/count = 0
		for(var/mob/player/client/P in world)
			if(P.gamein)
				P<<sound(SOUND_NUKE)
		sleep(43)
		for(var/mob/Monster/M in world)
			count ++
			death_zombie("NUK3",M)
		for(var/mob/player/client/P in world)
			if(P.gamein)
				var/obj/nuke_effect/N = new()
				P.client.screen+=N
				N.screen_loc = "1,1 to 15,15"
				flick("expl",N)
				spawn(14)
					del(N)
				P.kills += count
		check_killr(1)

	Freeze()
		set category = "Admin"
		set name = "Freeze"
		if(GMLockCheck())
			usr<<"<font color=red>Your Admin Powers Are Locked."
			return
		var/list/People[] = list()
		for(var/mob/P in world)
			if(!P||!P.client)continue
			People["[P] ([P.key])"]=P
		var/mob/player/client/M = People[input(src,"Freeze Who","Freeze")as null|anything in People]
		if(M.GM_Level>=usr.GM_Level)
			GMMessage("[usr] tried Freezing [M].")
			return
		if(M)
			M.frozen = 1

	UnFreeze()
		set category = "Admin"
		set name = "UnFreeze"
		if(GMLockCheck())
			usr<<"<font color=red>Your Admin Powers Are Locked."
			return
		var/list/People[] = list()
		for(var/mob/P in world)
			if(!P||!P.client)continue
			People["[P] ([P.key])"]=P
		var/mob/player/client/M = People[input(src,"Freeze Who","Freeze")as null|anything in People]
		if(M)
			M.frozen = 0
			M.shopping = 0

/*	Owner_Room()
		set category = "Admin"
		set name = "Go to Owner Room"
		set desc = "Go to teh awesomehouse"
		if(GMLockCheck())
			usr<<"<font color=red>Your Admin Powers Are Locked."
			return
		if(GameOn==2)
			src << "You are not Playing!"
			return
		else
			src.loc=locate(/turf/Locations/OwnerRoom)*/

	Admin_Room()
		set category = "Admin"
		set name = "Go to Admin Room"
		set desc = "Go to teh awesomehouse"
		if(GMLockCheck())
			usr<<"<font color=red>Your Admin Powers Are Locked."
			return
		if(GameOn==2)
			src << "You are not Playing!"
			return
		else
			src.loc=locate(/turf/Locations/AdminRoom)

	Leave_AdminR()
		set category = "Admin"
		set name = "Leave Admin Room"
		set desc = "Leave teh awesomehouse"
		if(GMLockCheck())
			usr<<"<font color=red>Your Admin Powers Are Locked."
			return
		if(GameOn==2)
			src << "You are not Playing!"
			return
		else
			var/list/sroom = new/list()
			for(var/turf/Locations/StartRoom/L in world)
				sroom += L
			src.loc=pick(sroom)

	Change_Prefix()
		set category = "Admin"
		set name = "Change Prefix"
		set desc = "Change Someones prefix"
		if(GMLockCheck())
			usr<<"<font color=red>Your Admin Powers Are Locked."
			return
		var/list/People[] = list()
		for(var/mob/player/client/P in world)
			if(!P||!P.client)continue
			People["[P] ([P.key])"]=P
		if(!People.len){info(,list(src),"No one to edit.");return}
		var/mob/player/client/M = People[input(src,"Edit Prefix on who?","Prefix")as null|anything in People]
		if(M)
			M.prefix = input(src,"Set Their prefix to?","Prefix",M.prefix) as null|text
			M.prefix = copytext(M.prefix,1,100)
			src<<"- Chat Prefix: {[M.prefix]}"

	Change_Name()
		set category = "Admin"
		set name = "Change Name"
		set desc = "Change Name"
		if(GMLockCheck())
			usr<<"<font color=red>Your Admin Powers Are Locked."
			return
		var/list/People[] = list()
		for(var/mob/player/client/P in world)
			if(!P||!P.client)continue
			People["[P] ([P.key])"]=P
		if(!People.len){info(,list(src),"No one to edit.");return}
		var/mob/player/client/M = People[input(src,"Edit Name on who?","Name")as null|anything in People]
		if(M)
			M.kname = input(src,"Set Their name to?","Name",M.kname) as null|text
			M.kname = copytext(M.kname,1,50)
			src<<"- Chat Name: {[M.kname]}"

	Announce(T as text)
		set category = "Admin"
		set name = "Announce"
		set desc = "Announce somthing to the whole world"
		if(GMLockCheck())
			usr<<"<font color=red>Your Admin Powers Are Locked."
			return
		world<<"<font size=+2 color=red align=center><b>[usr] Announces:<br>[T]"

	Game_Start()
		set category = "Admin"
		set name = "Start"
		set desc = "Starts the game."
		if(GMLockCheck())
			usr<<"<font color=red>Your Admin Powers Are Locked."
			return
		if(GameOn==1)
			var/rdy=new/list()
			for(var/mob/player/client/M in world)
				if(!M||!M.client)continue
				if(M.gamein)rdy+=M.key
			if(length(rdy)<=1)
				if(gamemode=="Team Survival"){info(null,list(src),"* Not enough players to start the game. *");return}
			if(!length(rdy)){info(null,list(src),"* Theres no players to start the game. *");return}
			var/list/startlist=new/list()
			for(var/turf/Locations/Mayham_Start/L in world)
				startlist+=L
			if(!length(startlist)){info(null,list(src),"* error! start location was not found. *");return}
			GameOn=2
			game_status="Game In Progress"
			src.verbs-=/mob/Host/verb/Game_Start
			src.verbs+=/mob/Host/verb/Spawn_Boss
			Current_Music=pick(rand_map_music)
			if(gamemode=="Team Survival")
				blueadd=0
				redadd=0
				for(var/mob/player/client/M in world)
					if(!M||!M.client)continue
					if(M.gamein)
						if(blueadd>redadd){redadd++;M.team="Red"}
						else {blueadd++;M.team="Blue"}
						M.create_tag(M.team)
			for(var/mob/player/client/M in world)
				if(!M||!M.client)continue
				if(M.gamein)
					if(M.music){
						M<<sound(null)
						latejoiner_list+="[M.key]"
						M<<sound(null)
						M.verbs+=/mob/player/client/verb/Suicide
						M<<sound(Current_Music,1,volume=80)}
					if(M.team=="Red")M.loc=locate(/turf/Locations/Red)
					else if(M.team=="Blue")M.loc=locate(/turf/Locations/Blue)
					else M.loc=pick(startlist)
					latejoiner_list+="[M.key]"
				else
					if(!lj)M.verbs-=/mob/player/client/verb/Join_game
					M.verbs+=/mob/Ogame/verb/Observe
			if(gamemode=="Protect The Teammate")
				var/list/pl=new/list()
				for(var/mob/player/client/M in world)
					if(!M||!M.client)continue
					if(M.gamein)pl+="[M.key]"
				protect=pick(pl)
				info(null,world,"<b><font size='4' color='#4682B4'> Protect: [protect]</font></b>")
			world << "<font color=[FIRSTCOLOR]><b>- <font color=green>BioHazard A.I.<font color=null>: Round Begining. All Player be on guard. Estimated time till Zombies reach outter barrier (30 Seconds)."
			spawn()
				nomounting=0
				explosive=1
				if(!timespawn(30))return
				var/C_MUSIC=MUSIC_MZ
				var/volumes = 70
				if(Difficulty=="Medium")C_MUSIC=pick(rand_battle_music_medium)
				else if(Difficulty=="Hard")C_MUSIC=pick(rand_battle_music_hard)
				else if(Difficulty=="Extreme")
					C_MUSIC = pick(rand_battle_music_expert)
				Current_Music=C_MUSIC
				for(var/mob/player/client/M in world)
					if(!M||!M.client)continue
					if(M.gamein||M.watch)
						if(M.music){M<<sound(null);M<<sound(Current_Music,1,volume=volumes)}
						//else {M<<sound(null);M<<sound(MUSIC_MZ,1,volume=60)}
				world<<"<b><font color=[FIRSTCOLOR]>- <font color=green>BioHazard A.I.<font color=null>: Attention Everyone! Zombies have been detected within your vacinity!"
				spawn()spawner(/mob/Monster/Zombie, zombies, zombies, rand(5,20), spawn_zone)
				spawn()timer()
				bosssa=1
				if(!timespawn(200))return
				world<<"<b><font color=[FIRSTCOLOR]>- <font color=green>BioHazard A.I.<font color=null>: Attention Everyone! Lickers have been detected within your area!"
				spawn()spawner(/mob/Monster/Licker, lickers, lickers, rand(5,20), spawn_zone)
				if(!timespawn(200))return
				world<<"<b><font color=[FIRSTCOLOR]>- <font color=green>BioHazard A.I.<font color=null>: ATTENTION! Wolves, I repeat, <b>WOLVES</b> are attacking!"
				spawn()spawner(/mob/Monster/Wolf, wolves, wolves, rand(5,20), spawn_zone)
				if(!timespawn(200))return
				world<<"<b><font color=[FIRSTCOLOR]>- <font color=green>BioHazard A.I.<font color=null>: ATTENTION! Hunters are en route!!"
				spawn()spawner(/mob/Monster/Hunter, hunters, hunters, rand(5,20), spawn_zone)
				if(!timespawn(200))return
				world<<"<b><font color=[FIRSTCOLOR]>- <font color=green>BioHazard A.I.<font color=null>: Dear Lord, is that Blood?!"
				spawn()spawner(/mob/Monster/Crimson, crimsons, crimsons, rand(5,20), spawn_zone)
				if(!timespawn(200))return
				world<<"<b><font color=[FIRSTCOLOR]>- <font color=green>BioHazard A.I.<font color=null>: AACK! GET IT OFF!"
				spawn()spawner(/mob/Monster/Spider, spiders, spiders, rand(5,20), spawn_zone)
				if(!timespawn(200))return
				world<<"<b><font color=[FIRSTCOLOR]>- <font color=green>BioHazard A.I.<font color=null>: BBZZTTT..."
				spawn()spawner(/mob/Monster/Cerberus, cerberuss, cerberuss, rand(5,20), spawn_zone)
			updates()

	Start_Option()
		set category = "Admin"
		set name = "Start Option"
		set desc = "This will bring up the start settings if the host is afk."
		if(GMLockCheck())
			usr<<"<font color=red>Your Admin Powers Are Locked."
			return
		if(GameOn||GameOver||autoh)return
		var/option=get_settings(src)
		src<<browse(option,"window=Options;size=500x550;can_close=0;can_resize=1;can_minimize=1")

	ASave_Check()
		set category = "Admin"
		set name="A-Save Check"
		set desc = "This allows you to check all players saves."
		if(GMLockCheck())
			usr<<"<font color=red>Your Admin Powers Are Locked."
			return
		info(null,list(src),"<b>** Key | I.P Address | Cheating **")
		for(var/mob/player/client/p in world)
			if(!p||!p.client)continue
			var/c="No"
			for(var/obj/Pickup/Guns/G in p.contents)
				if(G.check_upgrades()){c="Yes";break}
			if(!p.client.address)info(null,list(src),"*[p] | <b><font color=[SECCOLOR]>[world.address]</b> | ([c])*")
			else info(null,list(src),"*[p] | <b><font color=[SECCOLOR]>[p.client.address]</b> | ([c])*")

	Save_Check()
		set category = "Admin"
		set name = "Save Check"
		set desc = "This allows you to check players saves."
		if(GMLockCheck())
			usr<<"<font color=red>Your Admin Powers Are Locked."
			return
		var/list/People[] = list()
		for(var/mob/player/client/P in world)
			if(!P||!P.client)continue
			People["[P] ([P.key])"]=P
		if(!People.len){info(,list(usr),"No one to save check.");return}
		var/mob/player/client/M = People[input(usr,"Savefile check who?","Save Check")as null|anything in People]
		if(M)
			var/text2show={"
				<html>
				<head><title>Hack Check</title></head>
				<body>
				<style type="text/css">
					body{background-color: #000000; color: silver; scrollbar-face-color: #303030; scrollbar-highlight-color: #7A7A7A; scrollbar-3dlight-color: #555555; scrollbar-darkshadow-color: #3D3D3D; scrollbar-shadow-color: #171717; scrollbar-arrow-color: #F7F7F7; scrollbar-track-color: #1C1C1C}
				</style>
				<table cellpadding="11" cellspacing="0" border="1" width="100%">
				<td>
				<b><u>[M]:</u></b><br>
				"}
			text2show+="Cash = [M.cash]<br>"
			text2show+="Items = [M.items]/[M.maxitems]<br>"
			for(var/obj/Pickup/Guns/G in M.contents)
				text2show+="----------------<br>"
				text2show+="<b><u>[G]:</u></b><br>"
				text2show+="Fire Power: <b>[G.fire_power]</b><br>"
				text2show+="Capacity: <b>[G.clip]/[G.mclip]</b><br>"
				text2show+="Fire-Rate: <b>[G.firerate]</b><br>"
				text2show+="Reload-Rate: <b>[G.reload_time]</b><br>"
			text2show+="</td></table>"
			src<<browse(text2show,"window=HC;size=320x420")

	World_Chat()
		set category = "Admin"
		set name = "World Chat"
		set desc = "Toggle world chat on/off"
		if(GMLockCheck())
			usr<<"<font color=red>Your Admin Powers Are Locked."
			return
		var/State = "OFF"
		if(global.chat == 1) State = "ON"
		switch(alert(usr,"Current global chat state: [State]","Toggle Global Chat","Toggle On","Toggle Off","Cancel"))
			if("Cancel") return
			if("Toggle On"){global.chat = 1;info(,world,"[usr] Enabled World Chat.")}
			if("Toggle Off"){global.chat = 0;info(,world,"[usr] Disabled World Chat.")}

	Ban(mob/M in world)
		set category = "Admin"
		set name = "Ban"
		set desc = "Ban a noobs Key/IP."
		if(GMLockCheck())
			usr<<"<font color=red>Your Admin Powers Are Locked."
			return
		if(M.GM_Level>usr.GM_Level)
			GMMessage("[usr] tried Baning [M].")
			GMMessage("Admin Protection Activated! [usr] has been booted!")
			del usr
			return
		if(M)
			var/BanKey = M.key
			var/BanIP = M.client.address
			if(BanIP)BanIP=world.address
			switch(alert(usr,"How will you ban [M.key]?","Ban","Key","Ip","Key and Ip"))
				if("Key")
					var/reason = input(usr,"Why are you banning?","Ban Reason")as null|text
					if(!reason) reason = "No reason supplied."
					if(BanKey in BanList)return
					addban(BanKey,null)
					if(M)del(M)
					info(null,world,"[BanKey] has been banned.([reason])")
				if("Ip")
					var/reason = input(usr,"Why are you banning?","Ban Reason")as null|text
					if(!reason) reason = "No reason supplied."
					if(BanIP in IPBanList)return
					addban(null,BanIP)
					if(M)del(M)
					info(null,world,"[BanKey] has been banned.([reason])")
				if("Key and Ip")
					var/reason = input(usr,"Why are you banning?","Ban Reason")as null|text
					if(!reason) reason = "No reason supplied."
					if(!(BanKey in BanList))addban(BanKey,null)
					if(!(BanIP in IPBanList))addban(null,BanIP)
					if(M)del(M)
					info(null,world,"[BanKey] has been banned.([reason])")

	Manual_Ban()
		set category = "Admin"
		set name = "Manual Ban"
		set desc = "Manual ban a noobs Key/IP."
		if(GMLockCheck())
			usr<<"<font color=red>Your Admin Powers Are Locked."
			return
		switch(alert(usr,"How will you m-ban?","M-Ban","Key","Ip","Cancel"))
			if("Key")
				var/BanKey = input(usr,"Enter the exact key to ban.","Ban")as null|text
				if(BanKey)
					if(BanKey in BanList)return
					addban(BanKey,null)
					info(null,list(src),"[BanKey] has been key-banned.")
			if("Ip")
				var/BanIP = input(usr,"Enter the exact ip to ban.","Ban")as null|text
				if(BanIP)
					if(BanIP in IPBanList)return
					addban(null,BanIP)
					info(null,list(src),"[BanIP] has been ip-banned.")

	Unban()
		set category = "Admin"
		set name = "Unban"
		set desc = "Unban someone who was reacently banned."
		if(GMLockCheck())
			usr<<"<font color=red>Your Admin Powers Are Locked."
			return
		switch(alert(usr,"Unban by...?","Unban","Key","IP","Cancel"))
			if("Key")
				if(!length(BanList)){info(,list(src),"The BanList is empty.")}
				var/UnbanKey = input(usr,"Unban which key?","Unban a Key")as null|anything in BanList
				if(UnbanKey)
					remban(UnbanKey,null)
					info(,list(src),"[UnbanKey] has been unbanned.")
				return
			if("IP")
				if(!length(IPBanList)){info(null,list(src),"The IPBanList is empty.");return}
				var/UnbanIP = input(usr,"Unban which IP ?","Unban an IP") as null|anything in IPBanList
				if(UnbanIP)
					remban(null,UnbanIP)
					info(null,list(src),"[UnbanIP] has been unbanned.")
				return

	Manual_Mute()
		set category = "Admin"
		set name="Manual Mute"
		set desc = "Manual Mute a noobs Key/IP."
		if(GMLockCheck())
			usr<<"<font color=red>Your Admin Powers Are Locked."
			return
		switch(alert(usr,"How will you mute?","M-Mute","Ip","Key","Cancel"))
			if("Ip")
				var/MuteIP = input(usr,"Type in the exact ip to mute.","Mute IP")as null|text
				if(MuteIP)
					if(MuteIP in IPMuteList)return
					addmute(null,MuteIP)
					info(null,list(src),"You added the IP: '[MuteIP]' to the mute list.")
			if("Key")
				var/MuteKey = input(usr,"Type in the exact key to mute.","Mute Key")as null|text
				if(MuteKey)
					if(MuteKey in MuteList)return
					addmute(MuteKey,null)
					info(null,list(src),"You added the Key: '[MuteKey]' to the mute list.")

	Mute(mob/M in world)
		set category = "Admin"
		set name="Mute"
		set desc = "Mute a noobs Key/IP."
		if(GMLockCheck())
			usr<<"<font color=red>Your Admin Powers Are Locked."
			return
		if(M.GM_Level>usr.GM_Level)
			GMMessage("[usr] tried Muteing [M].")
			GMMessage("Admin Protection Activated! [usr] has been booted!")
			del usr
			return
		if(M)
			var/MuteKey = M.key
			var/MuteIP = M.client.address
			if(!MuteIP)MuteIP = world.address
			switch(alert(src,"How will you mute [M.key]","Mute","Key","Ip","Key and Ip"))
				if("Key")
					var/reason = input(usr,"Why are you key-muting [MuteKey]?","Mute Reason")as null|text
					if(!reason) reason = "No reason supplied."
					if(MuteKey in MuteList)return
					addmute(MuteKey,null)
					info(null,world,"[MuteKey] has been muted.([reason])")
				if("Ip")
					var/reason = input(usr,"Why are you ip-muting [MuteKey]?","Mute Reason")as null|text
					if(!reason) reason = "No reason supplied."
					if(MuteIP in IPMuteList)return
					addmute(null,MuteIP)
					info(null,world,"[MuteKey] has been muted.([reason])")
				if("Key and Ip")
					var/reason = input(usr,"Why are you muting [MuteKey]?","Mute Reason")as null|text
					if(!reason) reason = "No reason supplied."
					if(!(MuteKey in MuteList))addmute(MuteKey,null)
					if(!(MuteIP in IPMuteList))addmute(null,MuteIP)
					info(null,world,"[MuteKey] has been muted.([reason])")

	Unmute()
		set category = "Admin"
		set name="Unmute"
		set desc = "Unmute Key/IP."
		if(GMLockCheck())
			usr<<"<font color=red>Your Admin Powers Are Locked."
			return
		switch(alert(usr,"Unmute by...?","Unmute","Key","IP","Cancel"))
			if("Key")
				if(!length(MuteList)){info(null,list(src),"The MuteList is empty.");return}
				var/UnmuteKey=input(src,"Unmute which key?","Unmute by Key")as null|anything in MuteList
				if(UnmuteKey)
					remmute(UnmuteKey,null)
					info(null,list(src),"[UnmuteKey] has been key-unmuted.")
			if("IP")
				if(!length(IPMuteList)){info(null,list(src),"The IPMuteList is empty.");return}
				var/UnmuteIP=input(src,"Unmute which ip?","Unmute by IP")as null|anything in IPMuteList
				if(UnmuteIP)
					remmute(null,UnmuteIP)
					info(null,list(src),"[UnmuteIP] has been ip-unmuted.")

	Boot(mob/M in world)
		set category = "Admin"
		if(GMLockCheck())
			usr<<"<font color=red>Your Admin Powers Are Locked."
			GMMessage("[usr] tried Booting [M] but his/her Admin powers are locked!")
			return
		switch(alert("Are you sure you want to boot [M]?","Boot [M]","Yes","No"))
			if("Yes")
				if(M.GM_Level>GM_Level)
					GMMessage("[usr] tried Booting [M].")
					GMMessage("Admin Protection Activated! [usr] has been booted!")
					del usr
					return
				else
					var/Reason=input("Input a reason if wanted.")as null|text
					if(Reason)
						world<<"<b>[M] has been <font color = red>Booted</font> by [src]. ([Reason])"
						del M
					else
						world<<"<b>[M] has been <font color = red>Booted</font> by [src]."
						del M
			if("No")
				return

	AWho()
		set category="Admin"
		set name="A-Who"
		set desc = "Gathers a list of information from all players."
		if(GMLockCheck())
			usr<<"<font color=red>Your Admin Powers Are Locked."
			return
		info(null,list(src),"Players Online: <b>[length(ClientKey)]</b>")
		for(var/mob/player/client/M in world)
			if(!M||!M.client)continue
			var/text2show="<b>([M.kills]) - [M.name]</b>"
			for(var/obj/Pickup/O in M.contents)text2show+="<IMG CLASS=icon SRC=\ref[O.icon] ICONSTATE='[O.icon_state]'>"
			if(!M.client.address)text2show+="-<b><font color=#FF3300> [world.address]</b>"
			else text2show+="-<b><font color=[SECCOLOR]> [M.client.address]</b>"
			info(null,list(src),"[text2show]")

	World_Info()
		set category = "Admin"
		set name = "World Info"
		set desc = "See the server's information"
		if(GMLockCheck())
			usr<<"<font color=red>Your Admin Powers Are Locked."
			return
		info(null,list(src),"* Server information *")
		info(null,list(src),"Address\t: [world.address]:[world.port]")
		info(null,list(src),"Computer\t: [world.system_type]")
		info(null,list(src),"CPU Usage\t: [world.cpu]")
		info(null,list(src),"Uptime\t\t: [duration(world.time)]")
		info(null,list(src),"Status\t\t: <br>\[[world.status]]")

	World_Shutdown()
		set category="Admin"
		set name = "World Shutdown"
		set desc = "Shutdown the world."
		if(GMLockCheck())
			usr<<"<font color=red>Your Admin Powers Are Locked."
			return
		world.Del()

	World_Reboot()
		set category = "Admin"
		set name = "World Reboot"
		set desc = "Reboot the world"
		if(GMLockCheck())
			usr<<"<font color=red>Your Admin Powers Are Locked."
			return
		for(var/mob/player/client/M in world)
			M.save_game()
		world.Reboot()

	Toggle_AutoHost()
		set category = "Admin"
		set name = "Toggle AutoHost"
		set desc = "This will toggle on/off the autohost which runs the server if you go AFK."
		if(GMLockCheck())
			usr<<"<font color=red>Your Admin Powers Are Locked."
			return
		if(autoh)
			autoh=0
			ahostm="Off"
			info(null,list(src),"Autohost will be deactivated next round or reboot.")
		else
			autoh=1
			ahostm="On"
			info(null,list(src),"Autohost will be activated next round or reboot.")

	Ghost()
		set category = "Admin"
		set name = "Ghost"
		set desc = "Turn into a ghost"
		if(GMLockCheck())
			usr<<"<font color=red>Your Admin Powers Are Locked."
			return
		src.density = !density
		src.invisibility = !invisibility

	Toggle_Blood()
		set category = "Admin"
		set name = "Toggle Blood"
		set desc = "This will toggle on/off the blood settings."
		if(GMLockCheck())
			usr<<"<font color=red>Your Admin Powers Are Locked."
			return

		if(!MAX_BLOOD)
			MAX_BLOOD = 5
			BLOODDROPRATE = 40
			info(null,list(src),"Blood has been enabled.")
		else
			MAX_BLOOD = 0
			BLOODDROPRATE = 0
			info(null,list(src),"Blood has been disabled.")

	Add_Enforcer()
		set category = "Admin"
		set name = "Add Enforcer"
		set desc = "Gives any player enforcer powers to watch the server if your too busy."
		if(GMLockCheck())
			usr<<"<font color=red>Your Admin Powers Are Locked."
			return
		if(length(Enforcer)>=maxenforcer){src<<"Maximum number of enforcers reached.([maxenforcer])";return}
		var/list/PCList[] = new()
		for(var/mob/player/client/p in world)
			if(!p||!p.client)continue
			if(p==usr||isenforcer(p))continue
			PCList["[p] ([p.key])"] = p
		var/mob/player/client/p = PCList[input(usr,"Add who?","Add Enforcer") as null|anything in PCList]
		if(p&&!isenforcer(p))
			if(length(Enforcer)>=maxenforcer){src<<"Maximum number of enforcers reached.([maxenforcer])";return}
			Enforcer+=p.key
			p.verbs+=typesof(/mob/enforce/verb)
			p.GM_Level=1
			p.title = "<font color = #800080>Enforcer"
			info(src,world,"gave [p] enforcer powers.")

	Remove_Enforcer()
		set category = "Admin"
		set name = "Remove Enforcer"
		set desc = "Removes a enforcer's powers."
		if(GMLockCheck())
			usr<<"<font color=red>Your Admin Powers Are Locked."
			return
		if(!length(Enforcer)){info(null,list(src),"The Enforcer list is empty.");return}
		var/Key=input(usr,"Remove which Enforcer?","Remove Enforcer")as null|anything in Enforcer
		if(Key&&Enforcer.Find(Key))
			Enforcer-=Key
			for(var/mob/player/client/p in world)
				if(p.key==Key)
					p.verbs-=typesof(/mob/enforce/verb)
					p.GM_Level=0
			info(src,world,"has removed [Key] enforcer powers.")

	Motd()
		set category = "Admin"
		set name = "Motd"
		set desc = "This will change the 'message of the day'."
		if(GMLockCheck())
			usr<<"<font color=red>Your Admin Powers Are Locked."
			return

		var/mess=input("Change motd to?","Motd",motdmessage)as null|message
		if(mess)
			motdmessage=mess
			info(null,world,"Motd has been changed.")
			motd={"
					<html>
					<title>Motd</title>
					<body>
					<STYLE>BODY{background-color: black; color:white}</STYLE>
					<table cellpadding="0" cellspacing="0" border="0" align="center">
					<td>
					<center><u><font size=4><font color=green>BioHazard</center></u></font></font size><p>

					[motdmessage]<p>
					</td>
					</table>
					</body>
					</html>
				"}

	World_Status()
		set category = "Admin"
		set name = "World Status"
		set desc = "Change the world's status"
		if(GMLockCheck())
			usr<<"<font color=red>Your Admin Powers Are Locked."
			return
		var/newstatus = input(usr,"Current world.status is: [world.status]","Change World Status",world.status)as null|message
		if(newstatus)world.status="[newstatus]"

	World_Visibility()
		set category = "Admin"
		set name = "World Visibility"
		set desc = "Toggle the server's visibility from the hub on/off."
		if(GMLockCheck())
			usr<<"<font color=red>Your Admin Powers Are Locked."
			return
		var/state = "Shown"
		if(!world.visibility) state = "Not Shown"
		switch(alert(usr,"The world is currently [state] on BYOND's hub,toggle?","World Visibility","Yes","No"))
			if("Yes")
				if(world.visibility)world.visibility = 0
				else world.visibility = 1
			if("No") return

	Spawn_Boss()
		set category = "Admin"
		set name = "Spawn Boss"
		set desc = "This will force a boss to spawn."
		if(GMLockCheck())
			usr<<"<font color=red>Your Admin Powers Are Locked."
			return
		if(GameOver||GameOn!=2||bossspawned||!bosssa)return
		var/i22=rand(1,18)
		Current_Music=MUSIC_MENACING_NEMISES
		switch(i22)
			if(1)info(null,world,"<b><font color=#8B0000>S..T..A..R..S..!")
			if(2){info(null,world,"<b><font color=#006400>Tyrant programs activated!");Current_Music=MUSIC_TRYRANT}
			if(3){info(null,world,"<b><font color=#00008B>You hear several loud crashes not too far from here...");Current_Music=MUSIC_MR_X}
			if(4){info(null,world,"<b><font color=#8B008B>Hypnos Tyrant activated");Current_Music=MUSIC_TRYRANT}
			if(5){info(null,world,"<b><font color=#1E90FF>Thanatos programs activated!")}
			if(6){info(null,world,"<b><font color=#006400>I am Alexia Ashford,for the pride of the Ashford family,I will kill you all! ");Current_Music=MUSIC_ALEXIA}
			if(7){info(null,world,"<b><font color=#FFA500>You here a satanic screech far off in the distance...");Current_Music=MUSIC_MALFORMATION_OF_G}
			if(8){info(null,world,"<b><font color=null>RAAAAAAAAAAWR!");Current_Music=MUSIC_MR_X}
			if(9){info(null,world,"<b><font color=#4682B4>Morpheus Tyrant unleased!");Current_Music=MUSIC_TRYRANT}
			if(10){info(null,world,"<b><font color=#4682B4>I'm Sick of these MotherFuckin Snakes on this MotherFuckin Plane!")}
			if(11){info(null,world,"<b><font color=#4682B4>Shadow Krauser has awoken from his slumber!")}
			if(12){info(null,world,"<b><font color=#8B0000>Devil Jester has awakened from his slumber")}
			if(13){info(null,world,"<b><font color=#1E90FF>Garrador has escaped from his prisonment!")}
			if(14){info(null,world,"<b><font color=null>You feel the ground shake and several loud noises around!")}
			if(15){info(null,world,"<b><font color=#4682B4>Krauser will have his revenge on mankind!")}
			if(16){info(null,world,"<b><font color=#006400>Secondary Tyrant programs activated!");Current_Music=MUSIC_TRYRANT}
			if(17){info(null,world,"<b><font color=#4682B4>Bitores Mendez has been awakened.")}
			if(18){info(null,world,"<b><font color=#006400>The Black Flash has come from the shadows!")}

		for(var/mob/player/client/M in world)
			if(!M||!M.client)continue
			if(M.gamein||M.watch)
				if(M.music){M<<sound(null);M<<sound(Current_Music,1)}
		if(i22==1)spawn()spawner(/mob/Monster/Boss/Nemises, 2, 2, 10, spawn_zone)
		else if(i22==2)spawn()spawner(/mob/Monster/Boss/Tyrant, 3, 3, 10, spawn_zone)
		else if(i22==3)spawn()spawner(/mob/Monster/Boss/MR_X, 4, 4, 10, spawn_zone)
		else if(i22==4)spawn()spawner(/mob/Monster/Boss/Hypnos_Tyrant, 2, 2, 10, spawn_zone)
		else if(i22==5)spawn()spawner(/mob/Monster/Boss/Thanatos, 3, 3, 10, spawn_zone)
		else if(i22==6)spawn()spawner(/mob/Monster/Boss/Alexia, 4, 4, 10, spawn_zone)
		else if(i22==7)spawn()spawner(/mob/Monster/Boss/William, 5, 5, 10, spawn_zone)
		else if(i22==8)spawn()spawner(/mob/Monster/Boss/Troll, 4, 4, 10, spawn_zone)
		else if(i22==9)spawn()spawner(/mob/Monster/Boss/Morpheus_Tyrant, 5, 5, 10, spawn_zone)
		else if(i22==10)spawn()spawner(/mob/Monster/Boss/Yawn, 3, 3, 10, spawn_zone)
		else if(i22==11)spawn()spawner(/mob/Monster/Boss/Shadow_Krauser, 4, 4, 10, spawn_zone)
		else if(i22==12)spawn()spawner(/mob/Monster/Boss/DevilJester, 5, 5, 10, spawn_zone)
		else if(i22==13)spawn()spawner(/mob/Monster/Boss/Garrador, 4, 4, 10, spawn_zone)
		else if(i22==14)spawn()spawner(/mob/Monster/Boss/Lisa_Trevor, 3, 3, 10, spawn_zone)
		else if(i22==15)spawn()spawner(/mob/Monster/Boss/Krauser_Boss, 5, 5, 10, spawn_zone)
		else if(i22==16)spawn()spawner(/mob/Monster/Boss/Tyrant2, 4, 4, 10, spawn_zone)
		else if(i22==17)spawn()spawner(/mob/Monster/Boss/BitoresMendez, 5, 5, 10, spawn_zone)
		else if(i22==18)spawn()spawner(/mob/Monster/Boss/Black_Flasher, 5, 5, 10, spawn_zone)

	Set_Server_Limit()
		set category = "Admin"
		set name = "Server Limit"
		set desc = "This will set how many players are allowed in your server."
		if(GMLockCheck())
			usr<<"<font color=red>Your Admin Powers Are Locked."
			return
		var/limit=input("Enter a number to set the server limit.","Server Limit",maxpeople) as null|num
		limit=round(limit)
		if(!limit||limit<0)return
		if(limit>100){info(null,list(src),"limit is too long 100 is limit.");limit=100}
		maxpeople=limit
		info(null,list(src),"MaxPeople: [maxpeople]")
		updates()

	HTML_Message(C as message)
		set category = "Admin"
		if(GMLockCheck())
			usr<<"<font color=red>Your Admin Powers Are Locked."
			return
		for(var/mob/M in world)
			var/html_doc = "<head><title>Announcment</title></head><body bgcolor=#000000 text=#FFFFFF><center><B><U><font color = red><font size=1><font face=Verdana>Announcement</U><BR>From: [usr]</font><BR><BR><font face=Verdana><font color=COCOCO>[C]"
			M << browse(html_doc,"window=Announce")

	Admin_Chat(T as text)
		set category = "Admin"
		if(GMLockCheck())
			usr<<"<font color=red>Your Admin Powers Are Locked."
			return
		GMChat(T)

	Stop_Music()
		set category = "Admin"
		if(GMLockCheck())
			usr<<"<font color=red>Your Admin Powers Are Locked."
			return
		world << sound(null)

	Play_Music(M as sound)
		set category="Admin"
		set name="Play Music"
		if(GMLockCheck())
			usr<<"<font color=red>Your Admin Powers Are Locked."
			return
		switch(alert("Are you sure","Are you sure","Yes","No"))
			if("Yes")
				world << sound(null)
				world << M
				world << "[usr] plays [M] to the world"
			else
				return

	Multi_Key_Check()
		set category = "Admin"
		if(GMLockCheck())
			usr<<"<font color=red>Your Admin Powers Are Locked."
			return
		var/Found[0]
		for(var/mob/player/client/M in world)
			if(Found.Find(M))continue
			if(M.client)
				for(var/mob/player/client/M2 in world)
					if(!M2.client)continue
					if(!M2)continue
					if(M == M2)continue
					if(M.client.address == M2.client.address)
						Found += M
						Found += M2
						usr << "<B>\red Match Found!"
						usr << "<B><font color = #999999>Name:</font> [M.name] <B><font color = #999999>- Key:</font> [M.key] <B><font color = #999999>- Address:</font> [M.client.address]."
						usr << "<B><font color = #999999>Name:</font> [M2.name] <B><font color = #999999>- Key:</font> [M2.key] <B><font color = #999999>- Address:</font> [M2.client.address]."

	Send_To(mob/M in world)
		set category = "Admin"
		if(GMLockCheck())
			usr<<"<font color=red>Your Admin Powers Are Locked."
			return
		if(M.GM_Level>usr.GM_Level)
			GMMessage("[usr] tried to Send To [M].")
			return
		switch(alert("Do you want to Send [M] to Something?","","Yes","No"))
			if("Yes")
				var/mob/new_location
				new_location = input("Teleport [M] to who?") as mob in world
				M.loc = locate(new_location.x,new_location.y-1,new_location.z)
				M << "\red [src] has Sent you to [new_location]"
			else
				return

	Pwipe(var/mob/player/client/M in world)
		set category = "Admin"
		set name = "Pwipe"
		set desc = "Reset Someones Account"
		if(GMLockCheck())
			usr<<"<font color=red>Your Admin Powers Are Locked."
			return
		if(M.GM_Level>=usr.GM_Level)
			GMMessage("[usr] tried Pwiping [M].")
			GMMessage("Admin Protection Activated! [usr] has been booted!")
			del usr
			return
		if(M)
			if(!src||!src.client)return
			var/savefile/F = new()
			F["Reset"]<<1
			M.client.Export(F)
			world<< "<font color=blue>[usr] has PWIPED [M]"
			del(M)

	Pwipe2(var/mob/player/client/M in world)
		set category = "Admin"
		set name = "Secret Pwipe"
		set desc = "Reset Someones Account"
		if(GMLockCheck())
			usr<<"<font color=red>Your Admin Powers Are Locked."
			return
		if(M.GM_Level>=usr.GM_Level)
			GMMessage("[usr] tried Pwiping [M].")
			GMMessage("Admin Protection Activated! [usr] has been booted!")
			del usr
			return
		if(M)
			if(!src||!src.client)return
			var/savefile/F = new()
			F["Reset"]<<1
			M.client.Export(F)
			del(M)

	EditVar(mob/O as obj|mob|turf|area in world)
		set category = "Admin"
		set name = "EditVar"
		set desc = "Edit someones var."
		if(GMLockCheck())
			usr<<"<font color=red>Your Admin Powers Are Locked."
			return
		var/Choices[0]
		for(var/V in O.vars) Choices+=V
		Choices-="key"
		Choices-="ckey"
		Choices-="contents"
		Choices-="verbs"
		Choices-="GM_Level"
		Choices-="GM_Muted"
		Choices-="GMLock"
		Choices-="vars"
		Choices-="group"
		Choices-="type"
		Choices-="parent_type"
		Choices-="client"
		Choices-="title"
		Choices-="umbase"
		Choices-="uabackup"
		Choices-="usbackup"
		Choices-="ubhbackup"
		Choices-="ctbackup"
		Choices-="gamein"
		Choices-="pwiped"
		Choices-="inventory"
		Choices-="hash"
		Choices-="chest"
		Choices-="item_save"
		Choices-="ammo"
		Choices-="otherammo"
		Choices-="ammolimits"
		Choices-="command"
		Choices-="acommand"
		Choices-="bhcommand"

		if(O)
			var/edit = input(src,"Which variable?","Edit") in Choices
			if(edit&&O)
				var/edit2 = input(src,"Set the var: [edit] = [O.vars[edit]] to?","Edit",O.vars[edit])as null|text
				if(edit2&&O)
					if(isnum(O.vars[edit]))O.vars[edit] = text2num(edit2)
					else O.vars[edit] = edit2
	Create()
		set name = "Create"
		set category = "Admin"
		if(GMLockCheck())
			usr<<"<font color=red>Your Admin Powers Are Locked."
			return
		var/varItem
		var/varType = input("What do you want to create?","Create") in list("Object","Mob","Turf","Cancel")
		if(varType == "Cancel")
			return
		if(varType == "Object")
			varItem = input("What do you want to make?","Create obj") in typesof(/obj) + list("Cancel") - list(/obj/Pickup/Guns/Thousand_Sons)
		if(varType == "Mob")
			varItem = input("What do you want to make?","Create mob") in typesof(/mob) + list("Cancel")
		if(varType == "Turf")
			varItem = input("What do you want to make?","Create turf") in typesof(/turf) + list("Cancel")
		if(varItem == "Cancel")
			return
		new varItem(locate(src.x,src.y,src.z))

	View_Enforcers()
		set category = "Admin"
		set name = "View Enforcer's"
		set desc = "Lets you see the server enforcers."
		if(GMLockCheck())
			usr<<"<font color=red>Your Admin Powers Are Locked."
			return
		if(!length(Enforcer)){src<<"Enforcer list is empty.";return}
		var/list/L=new/list()
		for(var/mob/player/client/p in world)
			if(!p||!p.client)continue
			L+=p.key
		usr<<"<b>Enforcers</b>:"
		for(var/v in Enforcer)
			var/online="Offline"
			if(v in L)online="Online"
			usr<<"\t[v]: [online]."

	Spawn_Elite_Boss()
		set category = "Admin"
		set name = "Spawn Elite Boss"
		set desc = "This will force a boss to spawn."
		if(GMLockCheck())
			usr<<"<font color=red>Your Admin Powers Are Locked."
			return
		if(GameOver||GameOn!=2||bossspawned||!bosssa)return
		var/i22=rand(1,4)
		Current_Music=MUSIC_MENACING_NEMISES

		switch(i22)
			if(1)info(null,world,"<b><font color=#4682B4>Wesker is here to personaly kick your ass!")
			if(2){info(null,world,"<b><font color=#006400>The Abomination has been unleashed upon the world!!");Current_Music=MUSIC_TRYRANT}
			if(3)info(null,world,"<b><font color = red>Mr. X about to drop some X rated bullshit on your ass!")
			if(4)info(null,world,"<b><font color=#4682B4>Oh Shit. Weskers big ass dragon is going to bite you in the ass!")
		for(var/mob/player/client/M in world)
			if(!M||!M.client)continue
			if(M.gamein||M.watch)
				if(M.music){M<<sound(null);M<<sound(Current_Music,1)}
		if(i22==1)spawn()spawner(/mob/Monster/Boss/Wesker, 5, 5, 10, spawn_zone)
		if(i22==2)spawn()spawner(/mob/Monster/Boss/Abomination, 5, 5, 10, spawn_zone)
		if(i22==3)spawn()spawner(/mob/Monster/Boss/MutatedMrX, 5, 5, 10, spawn_zone)
		if(i22==4)spawn()spawner(/mob/Monster/Boss/Wesker_Dragon, 5, 5, 10, spawn_zone)

	Clear_Bosses()
		set category = "Admin"
		set name = "Clear Bosses"
		set desc = "This will clear bosses from the field."
		if(GMLockCheck())
			usr<<"<font color=red>Your Admin Powers Are Locked."
			return

		var/BossType = input("Which Type?","Destroy") in list("All","Elite","Normal","Cancel")
		if(BossType == "Cancel")
			return
		if(BossType == "All")
			for(var/mob/Monster/Boss/Nemises/M in world)
				del(M)
			for(var/mob/Monster/Boss/Tyrant/M in world)
				del(M)
			for(var/mob/Monster/Boss/MR_X/M in world)
				del(M)
			for(var/mob/Monster/Boss/Hypnos_Tyrant/M in world)
				del(M)
			for(var/mob/Monster/Boss/Alexia/M in world)
				del(M)
			for(var/mob/Monster/Boss/William/M in world)
				del(M)
			for(var/mob/Monster/Boss/Troll/M in world)
				del(M)
			for(var/mob/Monster/Boss/Morpheus_Tyrant/M in world)
				del(M)
			for(var/mob/Monster/Boss/Yawn/M in world)
				del(M)
			for(var/mob/Monster/Boss/Shadow_Krauser/M in world)
				del(M)
			for(var/mob/Monster/Boss/DevilJester/M in world)
				del(M)
			for(var/mob/Monster/Boss/Garrador/M in world)
				del(M)
			for(var/mob/Monster/Boss/Lisa_Trevor/M in world)
				del(M)
			for(var/mob/Monster/Boss/Krauser_Boss/M in world)
				del(M)
			for(var/mob/Monster/Boss/Tyrant2/M in world)
				del(M)
			for(var/mob/Monster/Boss/BitoresMendez/M in world)
				del(M)
			for(var/mob/Monster/Boss/Black_Flasher/M in world)
				del(M)
			for(var/mob/Monster/Boss/Wesker/M in world)
				del(M)
			for(var/mob/Monster/Boss/Wesker_Dragon/M in world)
				del(M)
			for(var/mob/Monster/Boss/Abomination/M in world)
				del(M)
			for(var/mob/Monster/Boss/MutatedMrX/M in world)
				del(M)
			for(var/mob/Monster/Boss/Thanatos/M in world)
				del(M)
		if(BossType == "Elite")
			for(var/mob/Monster/Boss/Wesker/M in world)
				del(M)
			for(var/mob/Monster/Boss/Wesker_Dragon/M in world)
				del(M)
			for(var/mob/Monster/Boss/Abomination/M in world)
				del(M)
			for(var/mob/Monster/Boss/MutatedMrX/M in world)
				del(M)
		if(BossType == "Normal")
			for(var/mob/Monster/Boss/Nemises/M in world)
				del(M)
			for(var/mob/Monster/Boss/Tyrant/M in world)
				del(M)
			for(var/mob/Monster/Boss/MR_X/M in world)
				del(M)
			for(var/mob/Monster/Boss/Hypnos_Tyrant/M in world)
				del(M)
			for(var/mob/Monster/Boss/Alexia/M in world)
				del(M)
			for(var/mob/Monster/Boss/William/M in world)
				del(M)
			for(var/mob/Monster/Boss/Troll/M in world)
				del(M)
			for(var/mob/Monster/Boss/Morpheus_Tyrant/M in world)
				del(M)
			for(var/mob/Monster/Boss/Yawn/M in world)
				del(M)
			for(var/mob/Monster/Boss/Shadow_Krauser/M in world)
				del(M)
			for(var/mob/Monster/Boss/DevilJester/M in world)
				del(M)
			for(var/mob/Monster/Boss/Garrador/M in world)
				del(M)
			for(var/mob/Monster/Boss/Lisa_Trevor/M in world)
				del(M)
			for(var/mob/Monster/Boss/Krauser_Boss/M in world)
				del(M)
			for(var/mob/Monster/Boss/Tyrant2/M in world)
				del(M)
			for(var/mob/Monster/Boss/BitoresMendez/M in world)
				del(M)
			for(var/mob/Monster/Boss/Black_Flasher/M in world)
				del(M)
			for(var/mob/Monster/Boss/Thanatos/M in world)
				del(M)

	Specific_Create()
		set name = "Specific Create"
		set category = "Admin"
		if(GMLockCheck())
			usr<<"<font color=red>Your Admin Powers Are Locked."
			return
		var/varItem
		var/varType = input("What do you want to create?","Create") in list("Cades","Turrets","NPC's","Guns","Items","Cancel")
		if(varType == "Cancel")
			return
		if(varType == "Cades")
			varItem = input("What do you want to make?","Create cade") in typesof(/obj/Pushable_Obj/Destroyable) + list("Cancel")
		if(varType == "Turrets")
			varItem = input("What do you want to make?","Create turret") in typesof(/mob/player/NPC/Obj) + list("Cancel")
		if(varType == "NPC's")
			varItem = input("What do you want to make?","Create NPC") in typesof(/mob/player/NPC/Mob) + list("Cancel")
		if(varType == "Guns")
			varItem = input("What do you want to make?","Create Gun") in typesof(/obj/Pickup/Guns) + list("Cancel") - list(/obj/Pickup/Guns/Thousand_Sons)
		if(varType == "Items")
			varItem = input("What do you want to make?","Create Item") in typesof(/obj/Pickup/Items) + list("Cancel")
		if(varItem == "Cancel")
			return
		new varItem(locate(src.x,src.y,src.z))

	Summon()
		set category = "Admin"
		set name = "Summon"
		set desc = "Summon someone to your location."
		if(GMLockCheck())
			usr<<"<font color=red>Your Admin Powers Are Locked."
			return
		var/list/People[] = list()
		for(var/mob/P in world)
			People["[P] ([P.key])"]=P
		if(!People.len){info(,list(src),"No one to save check.");return}
		var/mob/M = People[input(src,"Summon who?","Summon")as null|anything in People]
		if(M)M.loc=src.loc

	Teleport()
		set category = "Admin"
		set name = "Teleport"
		set desc = "Teleport to someones location."
		if(GMLockCheck())
			usr<<"<font color=red>Your Admin Powers Are Locked."
			return
		var/list/People[] = list()
		for(var/mob/P in world)
			People["[P] ([P.key])"]=P
		if(!length(People)){info(,list(src),"No one to save check.");return}
		var/mob/M = People[input(src,"Teleport to who?","Teleport")as null|anything in People]
		if(M)src.loc=M.loc

	Seticon(var/mob/player/client/M, I as icon)
		set name="Change Player Icon"
		set category="Admin"
		if(GMLockCheck())
			usr<<"<font color=red>Your Admin Powers Are Locked."
			return
		M.icon = I
		M.icon_state = input("Please select the icon state to use", "Set Icon") in icon_states(M.icon)
		M.ini_hicon = null
		M.ini_icon = M.icon
		M.savenload_icon(1)

	Pwipe_World()
		set name="World Pwipe"
		set category="Admin"
		if(GMLockCheck())
			usr<<"<font color=red>Your Admin Powers Are Locked."
			return
		if(wpwipe == null)
			wpwipe = 0
		if(wpwipe == 1)
			wpwipe = 0
			world << "World Pwipe has been disabled!"
			return

		if(wpwipe == 0)
			switch(alert("Are you sure you want to world pwipe?","","Yes","No"))

				if("Yes")
					wpwipe = 1
					world << "World Pwipe has been Enabled! All profiles will be deleted on relog!"

				else
					return

	Admin_Lock(var/mob/player/client/M in world)
		set category="Admin"
		if(GMLockCheck())
			usr<<"<font color=red>Your Admin Powers Are Locked."
			return
		if(M.GMLock==1)
			usr<<"<font color=red>Their Powers Are Locked!"
			return
		switch(alert("Are you sure you want to lock [M]'s admin powers?","Lock [M]","Yes","No"))
			if("Yes")
				goto Yes
			if("No")
				return
		return
		Yes
		if(M.GM_Level > GM_Level)
			GMMessage("[usr] tried Locking [M]'s Admin Powers")
			world << "[usr] has been booted for trying an illegal Admin function"
			del usr
			GMMessage("Admin Protection Activated! [usr] has been booted!")
			return
		var/Reason=input({"Input Reason. Reasons for this action WILL be checked, unless explained
elsewhere. If a stupid reason is given, your admin powers may be stripped."})as text
		M.GMLock=1
		M.GM_Level=0
		GMMessage("[usr] Locked [M]'s Admin Powers ~ Reason: [Reason]")


	Admin_UnLock(var/mob/player/client/M in world)
		set category="Admin"
		if(GMLockCheck())
			usr<<"<font color=red>Your Admin Powers Are Locked."
			return
		if(M.GMLock==0)
			usr<<"<font color=red>Their Powers Aren't Locked!"
			return
		switch(alert("Are you sure you want to unlock [M]'s admin powers?","UnLock [M]","Yes","No"))
			if("Yes")
				goto Yes
			if("No")
				return
		return
		Yes
		M.GMLock=0
		M.Check_Admin()
		GMMessage("[usr] UnLocked [M]'s Admin Powers")


	Warn(var/mob/player/client/M in world)
		set category="Admin"
		if(GMLockCheck())
			usr<<"<font color=red>Your Admin Powers Are Locked."
			return
		switch(alert("Are you sure you want to warn [M]?","Warn [M]","Yes","No"))
			if("Yes")
				goto Yes
			if("No")
				return
		return
		Yes
		var/Warn=input("Include What In The Warning? (Admin Warning: \[Warning\])")as text
		var/Type=input("Alert (Popup) or send in chat bar?")in list(/*"Alert"*/,"Text")
		if(Type=="Alert")
			M<<alert("Admin Warning: [Warn] ~ [usr]")
		if(Type=="Text")
			M<<"<font color =#105090><font color=red>Admin Warning: </font>[Warn] ~ [usr]"
		GMMessage("[usr] Warned [M]: [Warn].")


	Repop()
		set category="Admin"
		if(GMLockCheck())
			usr<<"<font color=red>Your Admin Powers Are Locked."
			return
		switch(alert("Are you sure you want to repop the world?","Repop","Yes","No"))
			if("Yes")
				goto Yes
			if("No")
				return
		return
		Yes
		world.Repop()
		world<<"<font size=0><font color=green>World Repop."
		GMMessage("[usr] Repopped the world.")

	Server_Connection()
		set category = "Admin"
		set name = "Server_Connection"
		set desc = "You can input your internet connection so people can see what i-connection there playing on."
		if(GMLockCheck())
			usr<<"<font color=red>Your Admin Powers Are Locked."
			return
		var/mess=input(src,"Enter your internet connection. 1 - 12","Server Connection",iconnection)as null|text
		if(mess)
			if(length(mess)>12)mess=copytext(mess,1,12)
			iconnection=mess
			info(null,list(src),"Connection Changed.")
			updates()
	Loc_Boss_Spawn(var/mob/player/client/M in world)
		set category = "Admin"
		set desc = "Spawn A Rape Boss at your loc"
		if(GMLockCheck())
			usr<<"<font color=red>Your Admin Powers Are Locked."
			return
		var/varItem1 = /mob/Monster/Boss/Wesker
		new varItem1(locate(M.x,M.y-1,M.z))
		new varItem1(locate(M.x,M.y-1,M.z))
		new varItem1(locate(M.x,M.y-1,M.z))
		new varItem1(locate(M.x,M.y-1,M.z))
		new varItem1(locate(M.x,M.y-1,M.z))
		var/varItem2 = /mob/Monster/Boss/Abomination
		new varItem2(locate(M.x,M.y-1,M.z))
		new varItem2(locate(M.x,M.y-1,M.z))
		new varItem2(locate(M.x,M.y-1,M.z))
		new varItem2(locate(M.x,M.y-1,M.z))
		new varItem2(locate(M.x,M.y-1,M.z))
		var/varItem3 = /mob/Monster/Boss/MutatedMrX
		new varItem3(locate(M.x,M.y-1,M.z))
		new varItem3(locate(M.x,M.y-1,M.z))
		new varItem3(locate(M.x,M.y-1,M.z))
		new varItem3(locate(M.x,M.y-1,M.z))
		new varItem3(locate(M.x,M.y-1,M.z))
		var/varItem4 = /mob/Monster/Boss/Wesker_Dragon
		new varItem4(locate(M.x,M.y-1,M.z))
		new varItem4(locate(M.x,M.y-1,M.z))
		new varItem4(locate(M.x,M.y-1,M.z))
		new varItem4(locate(M.x,M.y-1,M.z))
		new varItem4(locate(M.x,M.y-1,M.z))

	Full_STFU_Lock(var/mob/player/client/M in world)
		set category = "Admin"
		if(GMLockCheck())
			usr<<"<font color=red>Your Admin Powers Are Locked."
			return
		var/MuteKey = M.key
		addmute(MuteKey,null)
		M.GMLock = 1
		world << "<font color=[FIRSTCOLOR]><b>- <font color=green>BioHazard A.I.<font color=null>: STFU [M]"

	Force_Save(var/mob/player/client/M)
		set category = "Admin"
		set desc = "Forces Somebody to Auto Save"
		if(GMLockCheck())
			usr<<"<font color=red>Your Admin Powers Are Locked."
			return
		M.save_game()
		M << "Your data has been Force Saved by [usr]"



	Force_Suicide(var/mob/player/client/M in world)
		set category = "Admin"
		set desc = "Force a Player to Suicide"
		if(GameOn == 0)return
		if(GameOn == 1)return
		if(GameOn == 2)
			M.gamein=0
			M.weapon=null
			M.weapon2=null
			if(M.incar)
				if(M.incar.main.topright.topright==M)
					M.incar.main.topright.topright=0
					if(M.incar.main.driver)
						if(M in M.incar.main.driver.trspot)
							M.incar.main.driver.trspot-=M
				else if(M.incar.main.bottomright.bottomright==M)
					M.incar.main.bottomright.bottomright=0
					if(M.incar.main.driver)
						if(M in M.incar.main.driver.brspot)
							M.incar.main.driver.brspot-=M
				else if(M.incar.main.bottomleft.bottomleft==M)
					M.incar.main.bottomleft.bottomleft=0
					if(M.incar.main.driver)
						if(M in M.incar.main.driver.blspot)
							M.incar.main.driver.blspot-=M
				M.invisibility=0
				M.incar=0
			else if(M.driver)
				M.driver.main.driver=0
				M.driver=0
				M.tlspot=new/list()
				M.trspot=new/list()
				M.blspot=new/list()
				M.brspot=new/list()
				M.invisibility = 0
			if(M.sniper_mode)
				M.sniper_mode = 0
				M.client.eye = M
				M.eye_x=10
				M.eye_y=10
				M.eye_z=1
			M.hideunhide_hud(2,1,null)
			if(M.inventory)
				M.inventory=0
				M.updateihud(2)
				M.inventoryo(2)
			if(M.enemy_marker)del(M.enemy_marker)
			if(length(M.under_command))M.under_command=new/list()
			if(M.gender=="female")
				world <<"<b>[M]: Theres no point in living anymore."
				sleep(5)
				world <<"<b>*A Gunshot rings out*"
				sleep(5)
				world<<"<b>*([M]) Has taken her own life! ([M.kills] Kills)*"
			else
				world <<"<b>[M]: Theres no point in living anymore."
				sleep(5)
				world <<"<b>*A Gunshot rings out*"
				sleep(5)
				world<<"<b>*([M]) Has taken his own life! ([M.kills] Kills)*"
			check_r("[M.team]")
			M.mouse_over_pointer=null
			M.icon=null
			M.icon_state=null
			M.invisibility=1
			M.watch=1
			M.eye_x=M.x
			M.eye_y=M.y
			M.eye_z=M.z
			M.see_in_dark=14
			M.sight=SEE_MOBS
			M.client.eye=locate(M.eye_x,M.eye_y,M.eye_z)
			var/list/tscreen = new/list()
			for(var/turf/Locations/Title/L in world)
				tscreen += L
			M.loc=pick(tscreen)
			M.verbs+=/mob/Ogame/verb/Observe
			M.overlays=new/list()
			M.health=M.maxhealth
			if(length(spawn_zone))
				M.loc=pick(spawn_zone)
			M.alignment=1
			M.see_in_dark=12
			M.sight=SEE_MOBS

	Promote_Admin(var/mob/player/client/M in world)
		set category = "Admin"
		if(GMLockCheck())
			usr<<"<font color=red>Your Admin Powers Are Locked."
			return

		var/GM_Rank
		var/new_GM_Level = input("What Level of Admin do you wish to give them? (2-7)")as num | null

		if(!new_GM_Level)
			return

		if(new_GM_Level < 1 || new_GM_Level > 7)
			return

		if(new_GM_Level <= M.GM_Level)
			src << "Cannot Promote them to a Lower Level!"
			return

		if(M.GM_Level >= src.GM_Level)
			src << "You can only Promote Admin's lower rank than you!"
			return

		switch(new_GM_Level)
			if(2) GM_Rank = "Low Admin"
			if(3) GM_Rank = "Medium Admin"
			if(4) GM_Rank = "High Admin"
			if(5) GM_Rank = "Master Admin"
			if(6) GM_Rank = "Elite Admin"
			if(7) GM_Rank = "Head Admin"

		switch(alert({"Is This Correct?
Target: [M]
Selected Rank: [new_GM_Level], [GM_Rank]"},"Promoting Admin","Yes","No"))
			if("Yes")
				switch(M.GM_Level)
					if(2)
						Enforcer -= M.key
						LowAdmin -= M.key
						MediumAdmin -= M.key
						HighAdmin -= M.key
						MasterAdmin -= M.key
						EliteAdmin -= M.key
						HeadAdmin -= M.key
					if(3)
						Enforcer -= M.key
						LowAdmin -= M.key
						MediumAdmin -= M.key
						HighAdmin -= M.key
						MasterAdmin -= M.key
						EliteAdmin -= M.key
						HeadAdmin -= M.key
					if(4)
						Enforcer -= M.key
						LowAdmin -= M.key
						MediumAdmin -= M.key
						HighAdmin -= M.key
						MasterAdmin -= M.key
						EliteAdmin -= M.key
						HeadAdmin -= M.key
					if(5)
						Enforcer -= M.key
						LowAdmin -= M.key
						MediumAdmin -= M.key
						HighAdmin -= M.key
						MasterAdmin -= M.key
						EliteAdmin -= M.key
						HeadAdmin -= M.key
					if(6)
						Enforcer -= M.key
						LowAdmin -= M.key
						MediumAdmin -= M.key
						HighAdmin -= M.key
						MasterAdmin -= M.key
						EliteAdmin -= M.key
						HeadAdmin -= M.key
					if(7)
						Enforcer -= M.key
						LowAdmin -= M.key
						MediumAdmin -= M.key
						HighAdmin -= M.key
						MasterAdmin -= M.key
						EliteAdmin -= M.key
						HeadAdmin -= M.key
				switch(new_GM_Level)
					if(2)
						LowAdmin += M.key
						M.title = "<font color = #00ff00>Low Admin"
					if(3)
						MediumAdmin += M.key
						M.title = "\blue Medium Admin"
					if(4)
						HighAdmin += M.key
						M.title = "\red High Admin"
					if(5)
						MasterAdmin += M.key
						M.title = "<font color = #FFAE00>Master Admin"
					if(6)
						EliteAdmin += M.key
						M.title = "<font color = #00fa9a>Elite Admin"
					if(7)
						HeadAdmin += M.key
						M.title = "<font color = blue>Head Admin"
				M.GM_Level = new_GM_Level
				spawn(5) M.Apply_GM()
				GMMessage("[src] has Promoted [M] to Rank: [GM_Rank]")

			if("No")
				return

	Demote_Admin(var/mob/player/client/M in world)
		set category = "Admin"
		if(GMLockCheck())
			usr<<"<font color=red>Your Admin Powers Are Locked."
			return

		var/GM_Rank
		var/new_GM_Level = input("What Level of Admin do you wish to give them? (1-7)")as num | null

		if(!new_GM_Level)
			return

		if(new_GM_Level < 0 || new_GM_Level > 7)
			return

		if(new_GM_Level >= M.GM_Level)
			src << "Cannot Domote them to a higher level!"
			return

		if(new_GM_Level >= src.GM_Level)
			src << "You are not a high enough rank!"
			return

		if(M.GM_Level >= src.GM_Level)
			src << "You can only Demote Admin's lower rank than you!"
			return

		switch(new_GM_Level)
			if(0) GM_Rank = "Player"
			if(1) GM_Rank = "Enforcer"
			if(2) GM_Rank = "Low Admin"
			if(3) GM_Rank = "Medium Admin"
			if(4) GM_Rank = "High Admin"
			if(5) GM_Rank = "Master Admin"
			if(6) GM_Rank = "Elite Admin"
			if(7) GM_Rank = "Head Admin"

		switch(alert({"Is This Correct?
Target: [M]
Selected Rank: [new_GM_Level], [GM_Rank]"},"Demoting Admin","Yes","No"))
			if("Yes")
				switch(M.GM_Level)
					if(0)
						Enforcer -= M.key
						LowAdmin -= M.key
						MediumAdmin -= M.key
						HighAdmin -= M.key
						MasterAdmin -= M.key
						EliteAdmin -= M.key
						HeadAdmin -= M.key
					if(1)
						Enforcer -= M.key
						LowAdmin -= M.key
						MediumAdmin -= M.key
						HighAdmin -= M.key
						MasterAdmin -= M.key
						EliteAdmin -= M.key
						HeadAdmin -= M.key
					if(2)
						Enforcer -= M.key
						LowAdmin -= M.key
						MediumAdmin -= M.key
						HighAdmin -= M.key
						MasterAdmin -= M.key
						EliteAdmin -= M.key
						HeadAdmin -= M.key
					if(3)
						Enforcer -= M.key
						LowAdmin -= M.key
						MediumAdmin -= M.key
						HighAdmin -= M.key
						MasterAdmin -= M.key
						EliteAdmin -= M.key
						HeadAdmin -= M.key
					if(4)
						Enforcer -= M.key
						LowAdmin -= M.key
						MediumAdmin -= M.key
						HighAdmin -= M.key
						MasterAdmin -= M.key
						EliteAdmin -= M.key
						HeadAdmin -= M.key
					if(5)
						Enforcer -= M.key
						LowAdmin -= M.key
						MediumAdmin -= M.key
						HighAdmin -= M.key
						MasterAdmin -= M.key
						EliteAdmin -= M.key
						HeadAdmin -= M.key
					if(6)
						Enforcer -= M.key
						LowAdmin -= M.key
						MediumAdmin -= M.key
						HighAdmin -= M.key
						MasterAdmin -= M.key
						EliteAdmin -= M.key
						HeadAdmin -= M.key
					if(7)
						Enforcer -= M.key
						LowAdmin -= M.key
						MediumAdmin -= M.key
						HighAdmin -= M.key
						MasterAdmin -= M.key
						EliteAdmin -= M.key
						HeadAdmin -= M.key
				switch(new_GM_Level)
					if(0)
						M.title = null
					if(1)
						Enforcer += M.key
						M.title = "<font color = #800080>Enforcer"
					if(2)
						LowAdmin += M.key
						M.title = "<font color = #00ff00>Low Admin"
					if(3)
						MediumAdmin += M.key
						M.title = "\blue Medium Admin"
					if(4)
						HighAdmin += M.key
						M.title = "\red High Admin"
					if(5)
						MasterAdmin += M.key
						M.title = "<font color = #FFAE00>Master Admin"
					if(6)
						EliteAdmin += M.key
						M.title = "<font color = #00fa9a>Elite Admin"
					if(7)
						HeadAdmin += M.key
						M.title = "<font color = blue>Head Admin"
				M.GM_Level = new_GM_Level
				spawn(5) M.Remove_GM()
				spawn(5) M.Apply_GM()
				GMMessage("[src] has Demoted [M] to Rank: [GM_Rank]")

			if("No")
				return