mob/enforce/verb
	ASave_Check()
		set category = "Host"
		set name="A-Save Check"
		set desc = "This allows you to check all players saves."
		if(GMLockCheck())
			usr<<"<font color=red>Your Admin Powers Are Locked."
			return
		info(null,list(src),"<b>** Key | Cheating **")
		for(var/mob/player/client/p in world)
			if(!p||!p.client)continue
			var/c="No"
			for(var/obj/Pickup/Guns/G in p.contents)
				if(G.check_upgrades()){c="Yes";break}
			info(null,list(src),"*[p] | ([c])*")
	Mute(mob/M in world)
		set category = "Host"
		set name = "Mute"
		set desc = "Mute someone who is spamming or just being a noob."
		if(GMLockCheck())
			usr<<"<font color=red>Your Admin Powers Are Locked."
			return
		if(M.GM_Level>usr.GM_Level)
			GMMessage("[usr] tried Muteing [M].")
			GMMessage("Admin Protection Activated! [usr] has been booted!")
			del usr
			return
		if(M)
			var/MuteKey = M.key
			var/MuteIP = M.client.address
			if(!MuteIP)MuteIP = world.address
			switch(alert(src,"How will you mute [M.key]","Mute","Key","Ip","Key and Ip"))
				if("Key")
					var/reason = input(usr,"Why are you key-muting [MuteKey]?","Mute Reason")as null|text
					if(!reason) reason = "No reason supplied."
					if(MuteKey in MuteList)return
					addmute(MuteKey,null)
					info(null,world,"[MuteKey] has been muted.([reason])")
				if("Ip")
					var/reason = input(usr,"Why are you ip-muting [MuteKey]?","Mute Reason")as null|text
					if(!reason) reason = "No reason supplied."
					if(MuteIP in IPMuteList)return
					addmute(null,MuteIP)
					info(null,world,"[MuteKey] has been muted.([reason])")
				if("Key and Ip")
					var/reason = input(usr,"Why are you muting [MuteKey]?","Mute Reason")as null|text
					if(!reason) reason = "No reason supplied."
					if(!(MuteKey in MuteList))addmute(MuteKey,null)
					if(!(MuteIP in IPMuteList))addmute(null,MuteIP)
					info(null,world,"[MuteKey] has been muted.([reason])")
	Unmute()
		set category = "Host"
		set name = "Unmute"
		set desc = "Unmute a key"
		if(GMLockCheck())
			usr<<"<font color=red>Your Admin Powers Are Locked."
			return
		if(!isenforcer(src)){info(null,list(src),":/");return}
		if(!length(MuteList)){info(null,list(src),"The MuteList is empty.");return}
		var/UnmuteKey=input(usr,"Unmute which key?","Unmute by Key")as null|anything in MuteList
		if(UnmuteKey)
			remmute(UnmuteKey,null)
			info(null,list(src),"[UnmuteKey] has been key-unmuted.")
	World_Reboot()
		set category = "Enforcer"
		set name = "World Reboot"
		set desc = "Reboot the world"
		if(GMLockCheck())
			usr<<"<font color=red>Your Admin Powers Are Locked."
			return
		if(!isenforcer(src)){info(null,list(src),":/");return}
		world.Reboot()
	Start_Option()
		set category = "Enforcer"
		set name = "Start Option"
		set desc = "This will bring up the start settings if the host is afk."
		if(GMLockCheck())
			usr<<"<font color=red>Your Admin Powers Are Locked."
			return
		if(!isenforcer(src)){info(null,list(src),":/");return}
		if(GameOn||GameOver||autoh)return
		var/option=get_settings(src)
		src<<browse(option,"window=Options;size=500x550;can_close=0;can_resize=1;can_minimize=1")
	Toggle_AutoHost()
		set category = "Enforcer"
		set name = "Toggle AutoHost"
		set desc = "This will toggle on/off the autohost which can run the server."
		if(GMLockCheck())
			usr<<"<font color=red>Your Admin Powers Are Locked."
			return
		if(!isenforcer(src)){info(null,list(src),":/");return}
		if(autoh)
			autoh=0
			ahostm="Off"
			info(null,list(src),"Autohost will be deactivated next round or reboot.")
		else
			autoh=1
			ahostm="On"
			info(null,list(src),"Autohost will be activated next round or reboot.")