proc/auto_host()
	sleep(20)
	world<<"<font color=#006400><b><u><i>Artificial Intelligence Activated"
	sleep(15)
	world<<"<font color=[FIRSTCOLOR]><b>- <font color=green>BioHazard A.I.<font color=null>: Starting Round Setup....."
	zombies=rand(300,500)
	lickers=rand(20,80)
	hunters=rand(8,14)
	var/countz=0
	for(var/mob/player/client/p in world)
		if(!p||!p.client)continue
		countz++
	countz+=rand(3,6)
	maxzombies=round(rand(500,2000)*countz)
	tryagain
	Speed2=rand(18,26)
	if(Speed1>=Speed2)goto tryagain
	gamemode="Survival"
	vagain
	var/ii=rand(1,4)
	if(ii == 1)
		if(prob(40))
			if(countz>8)Difficulty="Medium"
			else Difficulty="Easy"
		else goto vagain
	else if(ii == 2)
		if(prob(30))
			if(countz>18)Difficulty="Hard"
			else Difficulty="Medium"
		else goto vagain
	else if(ii == 3)
		if(prob(20))
			if(countz>22)Difficulty="Extreme"
			else Difficulty="Hard"
		else goto vagain
	else if(ii == 4)
		if(prob(15))
			if(countz<8)Difficulty="Medium"
			else if(countz<12)Difficulty="Hard"
			else Difficulty="Extreme"
		else goto vagain
	td=0
	lj=rand(0,1)
	var/tdf=rand(0,1)
	if(tdf&&prob(30))td=1
	pz=rand(0,1)
	sleep(20)
	world<<"<font color=[FIRSTCOLOR]><b>- <font color=green>BioHazard A.I.<font color=null>: Setup Complete."
	sleep(10)
	world<<"<font color=[FIRSTCOLOR]><b>- <font color=green>BioHazard A.I.<font color=null>: Selecting Battle Location....."
	var/list/maps_picker=new/list()
	for(var/i=1,i<=length(map_list),i++)
		var/map_file=map_list[i]
		maps_picker+=map_list[map_file]
	for(var/i in flist("custom_maps/"))
		var/file_extension=copytext(i,length(i)-2,0)
		if(file_extension=="dmp")maps_picker+="custom_maps/[i]"
	sleep(10)
	maploading=1
	var/dmp_map=pick(maps_picker)
	if(findtext(dmp_map,"custom_maps"))Custom=1
	ahostm="Off"
	latejm="Off"
	tddm="Off"
	pzm="Off"
	if(autoh)ahostm="On"
	if(lj)latejm="On"
	if(td)tddm="On"
	if(pz)pzm="On"
	var/text=copytext("[dmp_map]",7,0)
	var/file_name=copytext(text,1,length(text)-3)
	current_map="[file_name]"
	world<<"<b><font color=[FIRSTCOLOR]>- <font color=green>BioHazard A.I.<font color=null>: Round Mode: <font color=[LOADERCOLOR]>'[gamemode]'</font>."
	world<<"<b><font color=[FIRSTCOLOR]>- <font color=green>BioHazard A.I.<font color=null>: Round Difficulty: <font color=[LOADERCOLOR]>'[Difficulty]'</font>."
	world<<"<b><font color=[FIRSTCOLOR]>- <font color=green>BioHazard A.I.<font color=null>: Loading the Location: <font color=[LOADERCOLOR]>'[file_name]'</font>, please wait..."
	var/dmp_reader/new_reader=new()
	new_reader.load_map(dmp_map)
	checkmap()
	world<<"<font color=[FIRSTCOLOR]><b>- <font color=green>BioHazard A.I.<font color=null>: Location has been selected..."
	sleep(10)
	world<<"<font color=[FIRSTCOLOR]><b>- <font color=green>BioHazard A.I.<font color=null>: You have 2 minutes till the fight of your life."
	Current_Music=pick(rand_save_room_music)
	GameOn=1
	spawn(1200)starting()
	updates()
	maploading=0


proc/starting()
	if(GameOn==1)
		var/count=0
		for(var/mob/player/client/M in world)
			if(!M||!M.client)continue
			if(M.gamein)
				count++
		if(!count)
			info(null,world,"<font color=[FIRSTCOLOR]><b>- <font color=green>BioHazard A.I.<font color=null>: Theres no players to start the game, will wait another 2 mins.")
			spawn(1200)starting()
			return
		var/list/startlist=new/list()
		for(var/turf/Locations/Mayham_Start/L in world)
			startlist+=L
		if(!length(startlist)){world<<"<font color=[FIRSTCOLOR]><b>- <font color=green>BioHazard A.I.<font color=null>:  error! start location was not found. reseting round.";spawn()boot_up(80);return}
		GameOn=2
		game_status="Game In Progress"
		Current_Music=pick(rand_map_music)
		for(var/mob/player/client/M in world)
			if(!M||!M.client)continue
			if(M.gamein)
				if(M.music){
					M<<sound(null)
					latejoiner_list+="[M.key]"
					M<<sound(null)
					M.verbs+=/mob/player/client/verb/Suicide
					M<<sound(Current_Music,1,volume=80)}
				M.loc=pick(startlist)
				latejoiner_list+="[M.key]"
			else
				if(!lj)M.verbs-=/mob/player/client/verb/Join_game
				M.verbs+=/mob/Ogame/verb/Observe
		spawn()
			nomounting=0
			explosive=1
			if(!timespawn(30))return
			var/C_MUSIC=MUSIC_MZ
			var/volumes = 70
			if(Difficulty=="Medium")C_MUSIC=pick(rand_battle_music_medium)
			else if(Difficulty=="Hard")C_MUSIC=pick(rand_battle_music_hard)
			else if(Difficulty=="Extreme")
				C_MUSIC=pick(rand_battle_music_expert)
			Current_Music=C_MUSIC
			for(var/mob/player/client/M in world)
				if(!M||!M.client)continue
				if(M.gamein||M.watch)
					if(M.music){
						M<<sound(null)
						M.verbs+=/mob/player/client/verb/Suicide
						M<<sound(Current_Music,1,volume=volumes)}
					//else {M<<sound(null);M<<sound(MUSIC_MZ,1,volume=60)}
			world<<"<b><font color=[FIRSTCOLOR]>- <font color=green>BioHazard A.I.<font color=null>: Attention Everyone! Zombies have been detected within your vacinity!"
			spawn()spawner(/mob/Monster/Zombie, zombies, zombies, rand(5,20), spawn_zone)
			spawn()timer()
			if(!timespawn(200))return
			world<<"<b><font color=[FIRSTCOLOR]>- <font color=green>BioHazard A.I.<font color=null>: Attention Everyone! Lickers have been detected within your area!"
			spawn()spawner(/mob/Monster/Licker, lickers, rand(1,3), rand(60,160), spawn_zone)
			if(!timespawn(200))return
			world<<"<b><font color=[FIRSTCOLOR]>- <font color=green>BioHazard A.I.<font color=null>: ATTENTION! Wolves, I repeat, <b>WOLVES</b> are attacking!"
			spawn()spawner(/mob/Monster/Wolf, wolves, rand(1,3), rand(60,160), spawn_zone)
			if(!timespawn(200))return
			world<<"<b><font color=[FIRSTCOLOR]>- <font color=green>BioHazard A.I.<font color=null>: ATTENTION! Hunters are en route!!"
			spawn()spawner(/mob/Monster/Hunter, hunters, rand(1,3), rand(60,160), spawn_zone)
			if(!timespawn(200))return
			world<<"<b><font color=[FIRSTCOLOR]>- <font color=green>BioHazard A.I.<font color=null>: Dear Lord, is that Blood?!"
			spawn()spawner(/mob/Monster/Crimson, crimsons, rand(1,3), rand(60,160), spawn_zone)
			if(!timespawn(200))return
			world<<"<b><font color=[FIRSTCOLOR]>- <font color=green>BioHazard A.I.<font color=null>: AACK! GET IT OFF!"
			spawn()spawner(/mob/Monster/Spider, spiders, rand(1,3), rand(60,160), spawn_zone)
			if(!timespawn(200))return
			world<<"<b><font color=[FIRSTCOLOR]>- <font color=green>BioHazard A.I.<font color=null>: BBZZTTT..."
			spawn()spawner(/mob/Monster/Cerberus, cerberuss, rand(1,3), rand(60,160), spawn_zone)
			if(!timespawn(200))return
			bossspawned=1
			var/i22=rand(1,3)
			Current_Music=MUSIC_MENACING_NEMISES
			switch(i22)
				if(1)info(null,world,"<b><font color=[FIRSTCOLOR]>- <font color=green>BioHazard A.I.<font color=null>: The Nemesis Program has been activated!")
				if(2){info(null,world,"<b><font color=[FIRSTCOLOR]>- <font color=green>BioHazard A.I.<font color=null>: Tyrant programs activated!");Current_Music=MUSIC_TRYRANT}
				if(3){info(null,world,"<b><font color=[FIRSTCOLOR]>- <font color=green>BioHazard A.I.<font color=null>: Attention! An unknown presences has been detected on the Battle Field. All Players be alert!");Current_Music=MUSIC_MR_X}
			for(var/mob/player/client/M in world)
				if(!M||!M.client)continue
				if(M.gamein||M.watch)
					if(M.music){M<<sound(null);M<<sound(Current_Music,1)}
			if(i22==1)spawn()spawner(/mob/Monster/Boss/Nemises, 2, 2, 10, spawn_zone)
			else if(i22==2)spawn()spawner(/mob/Monster/Boss/Tyrant, 3, 3, 10, spawn_zone)
			else if(i22==3)spawn()spawner(/mob/Monster/Boss/MR_X, 4, 4, 10, spawn_zone)
		updates()
