obj/Pickup
	tmp
		icon
		icon_state
	var/tmp
		cost = 100
	Guns
		var
			clip_level = 0
			firerate_level = 0
			gunpower_level = 0
			reloadtime_level = 0
			clip_level_cost = 100
			firerate_level_cost = 100
			gunpower_level_cost = 100
			reloadtime_level_cost = 100
			firerate = 10
			reload_time = 0
			fire_power = 0
			mclip = 0
			tmp
				//*****************************************
				clip = 0
				ammo = 0					//dont mess with this.
				maxammo = 0				//dont mess with this.
				//the above is not to be messed with
				//*****************************************
				can_upgrade_fr = 1 			//can we upgrade the guns fire-rate?         0 - No ** 1 - Yes
				can_upgrade_rs = 1			//can we upgrade the guns reload speed?      0 - No ** 1 - Yes
				can_upgrade_fp = 1			//can we upgrade the guns fire power?        0 - No ** 1 - Yes
				can_upgrade_cc = 1			//can we upgrade the guns clip capacity?     0 - No ** 1 - Yes
				overlay_add = null			//the weapon icon to add over our character.
				flicker = null				//the flick state for when we fore the gun.(ex: he moves a little bit when he fires a gun)
				reload_sound = null			//what does the gun sound liek when we reload it?
				shell_reload_sound = null			//what does the gun sound liek when we reload it?
				fire_sound = null			//what does the gun sound liek when we fire it?
				ammo_type = null			//what type of ammo does this gun use?
				sound_wav = 60				//how loud should it be?
				//*****************************************
				at = null/* what is the weapons ammo type?
					1 - 9mm Parabellum Rounds
					2 - .357 Magnum Rounds
					3 - 12 Gauge Shells
					4 - .45 ACP Rounds
					5 - 5.56mm NatO Rounds*/
				//*****************************************
				stype = 3/*what shooting type is the weapon?
					1 - single fire
					2 - 3 - burst fire
					3 - full-auto
					4 - shotgun blast*/
				//*****************************************
				fshoot = 0					//no description.
				duableg = 0					//can we dualwield this gun?                    0 - No ** 1 - Yes
				reload1 = 0
				spread2 = 0
				spread = 0					//does it spread and hit more than 1 target?    0 - No ** 1 - Yes
				ammo_path = null			//ammo it uses again but more defind.
				range = 16
				sniper = 0
				projectile = null
				grenade_launcher = null
				is_discard = 0
				propped = 0
				mode=0
				oclip=0
				list
					upgrade_fp=list(1=12,2=14,3=16,4=18,5=20)
					upgrade_rs=list(1=12,2=14,3=16,4=18,5=20)
					upgrade_mc=list(1=12,2=14,3=16,4=18,5=20)
					upgrade_fr=list(1=12,2=14,3=16,4=18,5=20)
		proc
			identify_ammo(var/mob/player/client/M, rload_type)
				if(!rload_type)
					if(src.grenade_launcher)
						switch(src.projectile)
							if(/obj/projectiles/acid)
								src.clip = M.otherammo["Acid"]
								src.ammo = M.ammo["Acid Rounds"]
							if(/obj/projectiles/flame)
								src.clip = M.otherammo["Flame"]
								src.ammo = M.ammo["Flame Rounds"]
							if(/obj/projectiles/freeze)
								src.clip = M.otherammo["Freeze"]
								src.ammo = M.ammo["Freeze Rounds"]
							if(/obj/projectiles/explosive)
								src.clip = M.otherammo["Explosive"]
								src.ammo = M.ammo["Explosive Rounds"]
					else
						if(src.sniper)
							M.sniper_range = src.range
						src.ammo = M.ammo["[src.ammo_type]"]
				else
					if(src.grenade_launcher)
						switch(src.projectile)
							if(/obj/projectiles/acid)
								M.otherammo["Acid"] = src.clip
								M.ammo["Acid Rounds"] = src.ammo
							if(/obj/projectiles/flame)
								M.otherammo["Flame"] = src.clip
								M.ammo["Flame Rounds"] = src.ammo
							if(/obj/projectiles/freeze)
								M.otherammo["Freeze"] = src.clip
								M.ammo["Freeze Rounds"] = src.ammo
							if(/obj/projectiles/explosive)
								M.otherammo["Explosive"] = src.clip
								M.ammo["Explosive Rounds"] = src.ammo
					else
						if(src.sniper)
							if(M.sniper_mode)
								M.sniper_range=16
								M.sniper_mode=0
								M.client.eye=M
								M.eye_x=10
								M.eye_y=10
								M.eye_z=1
						M.ammo["[src.ammo_type]"] = src.ammo
			/*	switch(src.at)
					if(1)
						if(!rload_type){src.ammo = M.ammo["9mm Parabellum Rounds"];src.maxammo = MAXLHAMMO}
						else M.ammo["9mm Parabellum Rounds"] = src.ammo
					if(2)
						if(!rload_type){src.ammo = M.ammo[".357 Magnum Rounds"];src.maxammo = MAXHHAMMO}
						else M.ammo[".357 Magnum Rounds"] = src.ammo
					if(3)
						if(!rload_type){src.ammo = M.ammo["12 Gauge Shells"];src.maxammo = MAXSGAMMO}
						else M.ammo["12 Gauge Shells"] = src.ammo
					if(4)
						if(!rload_type){src.ammo = M.ammo[".45 ACP Rounds"];src.maxammo = MAXACPAMMO}
						else M.ammo[".45 ACP Rounds"] = src.ammo
					if(5)
						if(!rload_type){src.ammo = M.ammo["5.56mm NatO Rounds"];src.maxammo = MAXNATOAMMO}
						else M.ammo["5.56mm NatO Rounds"] = src.ammo
					if(6)
						if(!rload_type){src.ammo = M.ammo["7.62x54mmR Rounds"];src.maxammo = MAXMMRAMMO}
						else M.ammo["7.62x54mmR Rounds"] = src.ammo
					if(7)
						if(!rload_type){src.ammo = M.ammo["Rockets"];src.maxammo = MAXROCKETAMMO}
						else M.ammo["Rockets"] = src.ammo*/
			check_upgrades()
				//if(src.can_upgrade_fr)
				if(src.firerate<src.upgrade_fr[length(src.upgrade_fr)])return 1
				//if(src.can_upgrade_rs)
				if(src.reload_time<src.upgrade_rs[length(src.upgrade_rs)])return 1
				//if(src.can_upgrade_fp)
				if(src.fire_power>src.upgrade_fp[length(src.upgrade_fp)])return 1
				//if(src.can_upgrade_cc)
				if(src.mclip>src.upgrade_mc[length(src.upgrade_mc)])return 1
				if(src.clip>(src.mclip+1))return 1
			check_reset()
				if(src.reload_time!=initial(src.reload_time)||src.mclip!=initial(src.mclip)||src.firerate!=initial(src.firerate)||src.fire_power!=initial(src.fire_power)||src.clip!=initial(src.clip))
					src.clip_level=initial(src.clip_level)
					src.firerate_level=initial(src.firerate_level)
					src.gunpower_level=initial(src.gunpower_level)
					src.reloadtime_level=initial(src.reloadtime_level)
					src.clip_level_cost=initial(src.clip_level_cost)
					src.firerate_level_cost=initial(src.firerate_level_cost)
					src.gunpower_level_cost=initial(src.gunpower_level_cost)
					src.reloadtime_level_cost=initial(src.reloadtime_level_cost)
					src.firerate=initial(src.firerate)
					src.reload_time=initial(src.reload_time)
					src.fire_power=initial(src.fire_power)
					src.mclip=initial(src.mclip)
					if(src.clip>src.mclip)src.clip=src.mclip
					return 1
			Equip_Proc(var/mob/player/client/M)
				if(!M||!M.client)return
				if(!M.weapon&&!M.weapon2)
					src.identify_ammo(M)
					src.suffix="[src.clip]/[src.mclip]"
					M.overlays+=src.overlay_add
					M.weapon=src
					M.lastclipn=10000
					M.hideunhide_hud(1,2,"Clip")
					if(M.inventory)M.updateihud(1,1)
					M<<sound(SOUND_CLICK,0,0,0,volume=(40-master_vol))
				else if(M.weapon&&!M.weapon2)
					if(src==M.weapon)
						src.identify_ammo(M,1)
						src.suffix=null
						M.overlays-=src.overlay_add
						M.weapon=null
						M.lastclipn=10000
						M.frozen=0
						M.hideunhide_hud(2,2,"Clip")
						M.reset_shud("Clip")
						if(M.inventory)M.updateihud(1,1)
						M<<sound(SOUND_CLICK,0,0,0,volume=(40-master_vol))
					else if(src.type==M.weapon.type&&src.duableg)
						src.suffix="[src.clip]/[src.mclip]"
						M.overlays+=src.overlay_add
						M.weapon2=src
						M.lastclipn2=10000
						M.hideunhide_hud(1,2,"Clip2")
						if(M.inventory)M.updateihud(1,1)
						M<<sound(SOUND_CLICK,0,0,0,volume=(40-master_vol))
					else
						M.weapon.identify_ammo(M,1)
						M.weapon.suffix=null
						M.overlays-=M.weapon.overlay_add
						M.weapon=null
						src.identify_ammo(M)
						src.suffix="[src.clip]/[src.mclip]"
						M.overlays+=src.overlay_add
						M.weapon=src
						M.lastclipn=10000
						M.frozen=0
						if(M.inventory)M.updateihud(1,1)
						M<<sound(SOUND_CLICK,0,0,0,volume=(40-master_vol))
				else if(M.weapon&&M.weapon2)
					if(src==M.weapon)
						src.identify_ammo(M,1)
						src.suffix=null
						M.overlays-=src.overlay_add
						M.weapon=null
						for(var/obj/Pickup/Guns/G in M.contents)
							if(G==M.weapon2){M.weapon2=null;M.weapon=G;break}
						M.weapon.identify_ammo(M)
						M.lastclipn=10000
						M.lastclipn2=10000
						M.hideunhide_hud(2,2,"Clip2")
						M.reset_shud("Clip2")
						if(M.inventory)M.updateihud(1,1)
						M<<sound(SOUND_CLICK,0,0,0,volume=(40-master_vol))
					else if(src==M.weapon2)
						src.suffix=null
						M.overlays-=src.overlay_add
						M.weapon2=null
						M.lastclipn2=10000
						M.hideunhide_hud(2,2,"Clip2")
						M.reset_shud("Clip2")
						if(M.inventory)M.updateihud(1,1)
						M<<sound(SOUND_CLICK,0,0,0,volume=(40-master_vol))
					else if(src.type!=M.weapon.type)
						M.weapon.identify_ammo(M,1)
						M.weapon.suffix=null
						M.overlays-=M.weapon.overlay_add
						M.weapon=null
						if(M.weapon2){M.weapon2.suffix=null;M.overlays-=M.weapon2.overlay_add;M.weapon2=null;M.hideunhide_hud(2,2,"Clip2");M.lastclipn2=10000;M.reset_shud("Clip2")}
						src.identify_ammo(M)
						src.suffix="[src.clip]/[src.mclip]"
						M.overlays+=src.overlay_add
						M.weapon=src
						M.lastclipn=10000
						if(M.inventory)M.updateihud(1,1)
						M<<sound(SOUND_CLICK,0,0,0,volume=(40-master_vol))
					else M<<"Unequip your current weapons."
		Click()
			var/mob/player/client/M=usr
			if(!M.gamein||GameOver)return
			if(length(M.contents)&&M.contents.Find(src))src.Equip_Proc(M)
		verb
			Drop()
				set category = "Commands"
				set src in usr
				set category = null
				var/mob/player/client/M=usr
				if(!(src in M))return
				if(!M.gamein||GameOver)return
				if(!src.suffix)
					src.check_reset()
					src.layer=initial(src.layer)
					src.loc=M.loc
					M.update_items()
					if(src.is_discard)del(src)
				else
					if(M.weapon&&M.weapon==src)
						if(M.weapon2)
							src.identify_ammo(M,1)
							src.suffix=null
							M.overlays-=src.overlay_add
							M.weapon=null
							for(var/obj/Pickup/Guns/G2 in M.contents)
								if(G2==M.weapon2){M.weapon2=null;M.weapon=G2;break}
							M.weapon.identify_ammo(M)
							M.lastclipn=10000
							M.lastclipn2=10000
							M.hideunhide_hud(2,2,"Clip2")
							M.reset_shud("Clip2")
						else
							src.identify_ammo(M,1)
							src.suffix=null
							M.overlays-=src.overlay_add
							M.weapon=null
							M.lastclipn=10000
							M.hideunhide_hud(2,2,"Clip")
							M.reset_shud("Clip")
					else if(M.weapon2&&M.weapon2==src)
						src.suffix=null
						M.overlays-=src.overlay_add
						M.weapon2=null
						M.lastclipn=10000
						M.hideunhide_hud(2,2,"Clip2")
						M.reset_shud("Clip2")
					src.check_reset()
					src.layer=initial(src.layer)
					src.loc=M.loc
					M.update_items()
					if(src.is_discard)del(src)
			Get()
				set src in oview(1)
				set category = null
				var/mob/player/client/M=usr
				if(!(src in oview(1)))return
				if(!M.gamein||GameOver)return
				if(M.check_items())
					M.contents+=src
					M.update_items()
			Check()
				set category = "Commands"
				set src in usr
				set category = null
				var/mob/player/client/M=usr
				var/html={"
					<html>
					<head><title>Hack Check</title></head>
					<body>
					<style type="text/css">
						body{background-color: #000000; color: silver; scrollbar-face-color: #303030; scrollbar-highlight-color: #7A7A7A; scrollbar-3dlight-color: #555555; scrollbar-darkshadow-color: #3D3D3D; scrollbar-shadow-color: #171717; scrollbar-arrow-color: #F7F7F7; scrollbar-track-color: #1C1C1C}
					</style>
					<table cellpadding="11" cellspacing="0" border="1" width="100%">
					<td>
					"}
				html+="<b><u><font size=5>[src.name]</font size=5></u></b>"
				html+="<br>"
				html+="<br>"
				html+="<br>"
				html+="<br>"
				html+="<br>"
				html+="<br>"
				html+="<br>"
				if(src.at!=3)html+="Lv.([src.clip_level]) <b>Magizine Capacity</b>: [src.mclip]"
				else html+="Lv.([src.clip_level]) <b>Chamber Capacity</b>: [src.mclip]"
				html+="<br>"
				html+="Lv.([src.firerate_level]) <b>Firing Speed</b>: [src.firerate]"
				html+="<br>"
				html+="Lv.([src.gunpower_level]) <b>FirePower</b>: [src.fire_power]"
				html+="<br>"
				html+="Lv.([src.reloadtime_level]) <b>Reload Speed</b>: [src.reload_time]"
				html+="</td></table>"
				M<<browse(html,"window=Information;size=370x340")
	Items
		var
			tmp
				ammotogive
				max_grouped_item=10
			ammount=1
		verb/Drop()
			set category = "Commands"
			set src in usr
			set category = null
			var/mob/player/client/M=usr
			if(!(src in M))return
			if(!M.gamein||GameOver)return
			src.ammount--
			if(src.ammount<=1)src.suffix=null
			else src.suffix="x[src.ammount]"
			var/O= src.type
			new O(M.loc)
			if(src.ammount<=0)M.contents-=src
			M.update_items()
			if(src.ammount<=0)del(src)
		verb/Drop_All()
			set category = "Commands"
			set src in usr
			set category = null
			var/mob/player/client/M=usr
			if(!(src in M))return
			if(!M.gamein||GameOver)return
			while(src.ammount)
				var/O= src.type
				new O(M.loc)
				src.ammount--
			if(src.ammount<=0)M.contents-=src
			M.update_items()
			if(src.ammount<=0)del(src)
		verb/Get()
			set category = "Commands"
			set src in oview(1)
			set category = null
			var/mob/player/client/M=usr
			if(!(src in oview(1))) return
			if(!M.gamein||GameOver)return
			if(!M.ammolimits["[src.name]"])
				if(prob(40))src<<"You cant carry that item."
				return
			switch(src.type)
				if(/obj/Pickup/Items/BasicAmmopack)
					var/obj/Pickup/Items/O=locate(src.type) in M.contents
					if(O)
						if(O.ammount>=M.ammolimits["[src.name]"]){M<<"Cant carry anymore [src.name].";return}
						else{O.ammount++;O.suffix="x[O.ammount]";M.update_items();del(src)}
					else
						if(!M.check_items()){M<<"Cant carry anymore items";return}
						M.contents+=src
						M.update_items()
				if(/obj/Pickup/Items/Army_QS_Turret)
					var/obj/Pickup/Items/O=locate(src.type) in M.contents
					if(O)
						if(O.ammount>=M.ammolimits["[src.name]"]){M<<"Cant carry anymore [src.name].";return}
						else{O.ammount++;O.suffix="x[O.ammount]";M.update_items();del(src)}
					else
						if(!M.check_items()){M<<"Cant carry anymore items";return}
						M.contents+=src
						M.update_items()
				if(/obj/Pickup/Items/BH_QS_Turret)
					var/obj/Pickup/Items/O=locate(src.type) in M.contents
					if(O)
						if(O.ammount>=M.ammolimits["[src.name]"]){M<<"Cant carry anymore [src.name].";return}
						else{O.ammount++;O.suffix="x[O.ammount]";M.update_items();del(src)}
					else
						if(!M.check_items()){M<<"Cant carry anymore items";return}
						M.contents+=src
						M.update_items()
				if(/obj/Pickup/Items/Minibase)
					var/obj/Pickup/Items/O=locate(src.type) in M.contents
					if(O)
						if(O.ammount>=M.ammolimits["[src.name]"]){M<<"Cant carry anymore [src.name].";return}
						else{O.ammount++;O.suffix="x[O.ammount]";M.update_items();del(src)}
					else
						if(!M.check_items()){M<<"Cant carry anymore items";return}
						M.contents+=src
						M.update_items()
				if(/obj/Pickup/Items/BasicDemopack)
					var/obj/Pickup/Items/O=locate(src.type) in M.contents
					if(O)
						if(O.ammount>=M.ammolimits["[src.name]"]){M<<"Cant carry anymore [src.name].";return}
						else{O.ammount++;O.suffix="x[O.ammount]";M.update_items();del(src)}
					else
						if(!M.check_items()){M<<"Cant carry anymore items";return}
						M.contents+=src
						M.update_items()
				if(/obj/Pickup/Items/BasicMedipack)
					var/obj/Pickup/Items/O=locate(src.type) in M.contents
					if(O)
						if(O.ammount>=M.ammolimits["[src.name]"]){M<<"Cant carry anymore [src.name].";return}
						else{O.ammount++;O.suffix="x[O.ammount]";M.update_items();del(src)}
					else
						if(!M.check_items()){M<<"Cant carry anymore items";return}
						M.contents+=src
						M.update_items()
				if(/obj/Pickup/Items/AQS_Barricade)
					var/obj/Pickup/Items/O=locate(src.type) in M.contents
					if(O)
						if(O.ammount>=M.ammolimits["[src.name]"]){M<<"Cant carry anymore [src.name].";return}
						else{O.ammount++;O.suffix="x[O.ammount]";M.update_items();del(src)}
					else
						if(!M.check_items()){M<<"Cant carry anymore items";return}
						M.contents+=src
						M.update_items()
				if(/obj/Pickup/Items/SQS_Barricade)
					var/obj/Pickup/Items/O=locate(src.type) in M.contents
					if(O)
						if(O.ammount>=M.ammolimits["[src.name]"]){M<<"Cant carry anymore [src.name].";return}
						else{O.ammount++;O.suffix="x[O.ammount]";M.update_items();del(src)}
					else
						if(!M.check_items()){M<<"Cant carry anymore items";return}
						M.contents+=src
						M.update_items()
				if(/obj/Pickup/Items/AQS_Turret)
					var/obj/Pickup/Items/O=locate(src.type) in M.contents
					if(O)
						if(O.ammount>=M.ammolimits["[src.name]"]){M<<"Cant carry anymore [src.name].";return}
						else{O.ammount++;O.suffix="x[O.ammount]";M.update_items();del(src)}
					else
						if(!M.check_items()){M<<"Cant carry anymore items";return}
						M.contents+=src
						M.update_items()
				if(/obj/Pickup/Items/SQS_Turret)
					var/obj/Pickup/Items/O=locate(src.type) in M.contents
					if(O)
						if(O.ammount>=M.ammolimits["[src.name]"]){M<<"Cant carry anymore [src.name].";return}
						else{O.ammount++;O.suffix="x[O.ammount]";M.update_items();del(src)}
					else
						if(!M.check_items()){M<<"Cant carry anymore items";return}
						M.contents+=src
						M.update_items()
				if(/obj/Pickup/Items/A_Backup)
					var/obj/Pickup/Items/O=locate(src.type) in M.contents
					if(O)
						if(O.ammount>=M.ammolimits["[src.name]"]){M<<"Cant carry anymore [src.name].";return}
						else{O.ammount++;O.suffix="x[O.ammount]";M.update_items();del(src)}
					else
						if(!M.check_items()){M<<"Cant carry anymore items";return}
						M.contents+=src
						M.update_items()
				if(/obj/Pickup/Items/S_Backup)
					var/obj/Pickup/Items/O=locate(src.type) in M.contents
					if(O)
						if(O.ammount>=M.ammolimits["[src.name]"]){M<<"Cant carry anymore [src.name].";return}
						else{O.ammount++;O.suffix="x[O.ammount]";M.update_items();del(src)}
					else
						if(!M.check_items()){M<<"Cant carry anymore items";return}
						M.contents+=src
						M.update_items()
				if(/obj/Pickup/Items/BH_Backup)
					var/obj/Pickup/Items/O=locate(src.type) in M.contents
					if(O)
						if(O.ammount>=M.ammolimits["[src.name]"]){M<<"Cant carry anymore [src.name].";return}
						else{O.ammount++;O.suffix="x[O.ammount]";M.update_items();del(src)}
					else
						if(!M.check_items()){M<<"Cant carry anymore items";return}
						M.contents+=src
						M.update_items()
				if(/obj/Pickup/Items/C_Backup)
					var/obj/Pickup/Items/O=locate(src.type) in M.contents
					if(O)
						if(O.ammount>=M.ammolimits["[src.name]"]){M<<"Cant carry anymore [src.name].";return}
						else{O.ammount++;O.suffix="x[O.ammount]";M.update_items();del(src)}
					else
						if(!M.check_items()){M<<"Cant carry anymore items";return}
						M.contents+=src
						M.update_items()
				if(/obj/Pickup/Items/TripWire)
					var/obj/Pickup/Items/TripWire/C=src
					if(C.armed)return
					var/obj/Pickup/Items/O=locate(src.type) in M.contents
					if(O)
						if(O.ammount>=M.ammolimits["[src.name]"]){M<<"Cant carry anymore [src.name].";return}
						else{O.ammount++;O.suffix="x[O.ammount]";M.update_items();del(src)}
					else
						if(!M.check_items()){M<<"Cant carry anymore items";return}
						M.contents+=src
						M.update_items()
				if(/obj/Pickup/Items/C4)
					var/obj/Pickup/Items/C4/C=src
					if(C.armed&&C.owner!=M.key){M<<"This bomb is armed. only [C.owner] can pick it up.";return}
					var/obj/Pickup/Items/O=locate(src.type) in M.contents
					if(O)
						if(O.ammount>=M.ammolimits["[src.name]"]){M<<"Cant carry anymore [src.name].";return}
						else{O.ammount++;O.suffix="x[O.ammount]";M.update_items();del(src)}
					else
						if(!M.check_items()){M<<"Cant carry anymore items";return}
						C.armed=0
						C.owner=0
						C.icon_state="C4"
						M.contents+=src
						M.update_items()
				if(/obj/Pickup/Items/TCure)
					var/obj/Pickup/Items/TCure/C=locate(src.type) in M.contents
					if(C)
						if(C.ammount>=M.ammolimits["[src.name]"]){M<<"Cant carry anymore [src.name].";return}
						else{C.ammount++;C.suffix="x[C.ammount]";M.update_items();del(src)}
					if(!M.check_items()){M<<"Cant carry anymore items";return}
					M.contents+=src
					M.update_items()
				if(/obj/Pickup/Items/Grenade)
					if(M.grenade>=M.ammolimits["[src.name]"]){M<<"Full";return}
					else {M.grenade++;del(src)}
				if(/obj/Pickup/Items/Land_Mine)
					var/obj/Pickup/Items/Land_Mine/C=src
					if(M.mine>=M.ammolimits["[src.name]"]){M<<"Full";return}
					else if(C.armed&&C.owner!=M){M<<"This mine is armed. only [C.owner] can pick it up.";return}
					else {M.mine++;del(src)}
				else
					for(var/obj/Pickup/Items/O in M.contents)
						if(O.type == src.type)
							if(O.ammount < M.ammolimits["[src.name]"])
								O.ammount++
								O.suffix="x[O.ammount]"
								M.update_items()
								del(src)
					if(!M.check_items()){M<<"Cant carry anymore items";return}
					M.contents+=src
					M.update_items()

obj/effects
	slash
		icon='icons/effects.dmi'
		icon_state="slash"
		layer=4
		New(loc,dir)
			src.dir=dir
			..()
			spawn(2)
				del(src)

