

mob/Monster
	mouse_opacity=0
	density=1
	alignment=1
	var/tmp
		mob/player/client/target
		turn = 1
		checks = 0
		sleeper = 0
		SPEED1 = 0
		SPEED2 = 0
	//	obj/dantum/dt = null
	proc
		Get_Target()
			var/list/get=new/list()
			for(var/mob/player/client/M in world)
				if(!M||!M.client)continue
				if(protect){if(M.gamein&&protect==M.key){get+=M;break}}
				else {if(M.gamein)get+=M}
			if(!length(get))return
			src.target=pick(get)
		Walk()
			while(!GameOver)
				if(src.sleeper)
					sleep(rand(50,70))
					src.sleeper = 0
				else if(src.frozen)
					sleep(rand(10,50))
					continue
				var/time = src.SPEED2
				if(!src.target||!src.target.gamein)
					src.Get_Target()
					time += rand(2,6)
				else
					if(prob(50))
						for(var/mob/player/client/MM in oview(rand(4,10),src))
							if(MM == src.target)continue
							if(MM.bleed_loop)
								src.target = MM
								break
					if(!turn)
						if(checks>=4)
							turn = 1
							checks = 0
						else checks++
					else if(prob(60) && turn)
						turn=0
						for(var/mob/player/P in oview(rand(4,6),src))
							if(!P||!P.gamein)continue
							soundmoan(P)
							if(!src.target||get_dist(src,P)<get_dist(src,src.target))
								src.target = P
					if(get_dist(src,src.target) <= 1)
						step_towards(src,src.target)
						sleep(rand(2,4))
					else
						var/a = 0
						for(var/obj/O in get_step(src,get_dir(src,src.target)))
							if(!O||!O.density||!O.attackable)continue
							src.Bump(O)
							a = 1
							break
						if(!a)
							if(!step_to(src,src.target))
								var/turf/T=get_step(src,get_dir(src,src.target))
								if(!T){sleep(rand(100,200));continue}
								if(T && !T.density)step_towards(src,src.target)
								else if(istype(src,/mob/Monster/Boss))
									flick("[src.icon_state]_attack",src)
									T.health-=rand(3,6)
									if(T.health<=0)T.Death()
									step_rand(src)
								else if(!step_rand(src))
									src.sleeper=1
				sleep(rand(src.SPEED1,time))

	Bump(atom/movable/A)
		..()
		if(!A)return
		if(istype(A,/obj/Destructable_Obj/Chainlink_Fence))
			flick("[src.icon_state]_attack",src)
			range(3,src)<<sound(SOUND_ZATTACK,volume=(60-master_vol))
			A.health-=rand(round(src.attack/2),src.attack)
			if(A.health<=0)A.Death()
		else if(istype(A,/mob))
			if(istype(A,/mob/player))
				var/mob/player/p=A
				if(p.gamein)
					if(istype(A,/mob/player/NPC))
						var/mob/player/NPC/N = A
						N.target = src
					else
						spawn()p:infection()
					var/moan=pick(list(SOUND_ZBITE,SOUND_ZBITE2))
					p<<moan
					new/obj/effects/Bit(p.loc)
					flick("[src.icon_state]_attack",src)
					range(3,src)<<sound(SOUND_ZATTACK,volume=(60-master_vol))
					p.health-=rand(round(src.attack/2),src.attack)
					if(p.health<=0)
						p.Death()
				else src.loc=p.loc
			else if(istype(A,/mob/Monster) && istype(src,/mob/Monster/Boss))
				if(prob(5))
					src.loc=A.loc
			else {if(!step_rand(src))src.sleeper=1}
		else if(istype(A,/obj/Vehicle))
			var/obj/Vehicle/V=A
			if(prob(80)&&V.main.health>0)
				flick("[src.icon_state]_attack",src)
				oview(3,src)<<sound(SOUND_ZATTACK,0,volume=(80-master_vol))
				V.main.health-=rand(0,6)
				if(V.main.health<=0){V.main.Death()}
		else if(istype(A,/obj/Windows))
			if(A.density)
				flick("[src.icon_state]_attack",src)
				range(3,src)<<sound(SOUND_ZATTACK,volume=(60-master_vol))
				A.health-=rand(round(src.attack/2),src.attack)
				if(A.health<=0)A.Death()
				else if(A.health<=3)A.icon_state="[A.name]broke"
				else if(A.health<=6)A.icon_state="[A.name]brok"
				else if(A.health<=8)A.icon_state="[A.name]bro"
		else if(istype(A,/obj/Door)||istype(A,/obj/Secured_Stuff/Big_Doors))
			if(A.density)
				flick("[src.icon_state]_attack",src)
				range(3,src)<<sound(SOUND_ZATTACK,volume=(60-master_vol))
				A.health-=rand(round(src.attack/2),src.attack)
				if(A.health<=0)A.Death()
				orange(A,3)<<sound(SOUND_DOOR,0,volume=70)
		else if(istype(A,/obj/Pushable_Obj/Pushable))
			flick("[src.icon_state]_attack",src)
			range(3,src)<<sound(SOUND_ZATTACK,volume=(60-master_vol))
			A.health-=rand(round(src.attack/2),src.attack)
			if(A.health<=0)
				A.Death()
		else if(istype(A,/obj/Pushable_Obj/Destroyable))
			if(!A)return..()
			oview(2,A)<<sound(SOUND_DOOR_CLOSE,0)
			flick("[src.icon_state]_attack",src)
			range(3,src)<<sound(SOUND_ZATTACK,volume=(60-master_vol))
			A.health-=rand(round(src.attack/2),src.attack)
			if(A.health<=0)A.Death()