mob/player/NPC
	New()
		..()
		spawn(5)
			for(var/turf/T in locate(src.x,src.y,src.z))
				if(T && T.density)
					del(src)
					return
		spawn(20)
			if(gamemode=="Team Survival")del(src)
			if(istype(src,/mob/player/NPC/Mob))
				var/inic = 0
				for(var/mob/player/NPC/Mob/M in world)
					inic++
				if(inic>maxnpc)del(src)
	gamein=1
	alignment=0
	proc
		NPC()
	var
		need_backup = 0
		ammo=0
		mammo=0
		clip
		mclip
		gun_power
		gun
		mob/Monster/target
		weapon_sound
		fire_speed
		flick_state
		weapon_volume=40
		commander=""
		commanded=0
		command=0
		acommand=0
		acommanded=0
		acommander=""
		bhcommand=0
		bhcommanded=0
		bhcommander=""
	Obj
		sentry_turret
			name="Sentry Turret"
			icon='icons/turret.dmi'
			icon_state="normal"
			health=8
			maxhealth=8
			see_in_dark=6
			New()
				src.flick_state="fire"
				src.weapon_sound=SOUND_AUG_1
				fire_speed=1
				gun_power=28
				clip=42
				mclip=42
				..()
				spawn()src.NPC()
			Death()
				del(src)
				icon_state="corpse"
				density=0
			NPC()
				if(GameOver)return
				if(!src.target)
					for(var/mob/Z in oview(rand(4,6),src))
						if(!Z.alignment)continue
						src.target=Z
						break
					if(src.target)
						spawn(src.fire_speed)src.NPC()
						return
					else
						spawn(rand(10,30))src.NPC()
						return
				else
					var/targetdist=get_dist(src.target,src)
					if(targetdist>6)
						src.target=null
						spawn(rand(3,6))src.NPC()
						return
					else if(targetdist<=6)
						if(src.clip>0)
							src.clip--
							src.dir=get_dir(src,src.target)
							orange(7,src)<<sound(src.weapon_sound,0,0,0,volume=(src.weapon_volume-master_vol))
							flick(src.flick_state,src)
							var/chancehit=100
							chancehit-=(10*targetdist)
							chancehit-=rand(1,8)
							if(prob(chancehit))
								//new/obj/blood_effects/splatter(src.target.loc)
								var/damage=src.gun_power
								if(prob(BLOODDROPRATE) && length(src.target.loc.overlays) < MAX_BLOOD)src.target.loc.overlays += new/obj/blood_effects/blood
								src.target.health-=damage
								if(src.target.health<=0)
									death_zombie(null,src.target)
							spawn(rand(1,2))src.NPC()
							return
						else
							sleep(50)
							src.clip=mclip
							spawn()src.NPC()
							return
					else
						spawn(rand(7,12))src.NPC()
						return
		AQS_turret
			name="Army Quick Setup Turret(Activated)"
			icon='icons/turret.dmi'
			icon_state="normal3"
			health=20
			maxhealth=20
			see_in_dark=5
			New()
				src.flick_state="fire3"
				src.weapon_sound=SOUND_AUG_1
				fire_speed=1
				gun_power=35
				clip=80
				mclip=80
				..()
				spawn()src.NPC()
			Death()
				del(src)
				icon_state="corpse3"
				density=0
			NPC()
				if(GameOver)return
				if(!src.target)
					for(var/mob/Z in oview(rand(4,6),src))
						if(!Z.alignment)continue
						src.target=Z
						break
					if(src.target)
						spawn(src.fire_speed)src.NPC()
						return
					else
						spawn(rand(10,30))src.NPC()
						return
				else
					var/targetdist=get_dist(src.target,src)
					if(targetdist>6)
						src.target=null
						spawn(rand(3,6))src.NPC()
						return
					else if(targetdist<=6)
						if(src.clip>0)
							src.clip--
							src.dir=get_dir(src,src.target)
							orange(7,src)<<sound(src.weapon_sound,0,0,0,volume=(src.weapon_volume-master_vol))
							flick(src.flick_state,src)
							var/chancehit=100
							chancehit-=(10*targetdist)
							chancehit-=rand(1,8)
							if(prob(chancehit))
								//new/obj/blood_effects/splatter(src.target.loc)
								var/damage=src.gun_power
								if(prob(BLOODDROPRATE) && length(src.target.loc.overlays) < MAX_BLOOD)src.target.loc.overlays += new/obj/blood_effects/blood
								src.target.health-=damage
								if(src.target.health<=0)
									death_zombie(null,src.target)
							spawn(rand(1,2))src.NPC()
							return
						else
							sleep(50)
							src.clip=mclip
							spawn()src.NPC()
							return
					else
						spawn(rand(7,12))src.NPC()
						return

		SQS_turret
			name="S.W.A.T. Quick Setup Turret(Activated)"
			icon='icons/turret.dmi'
			icon_state="normal4"
			health=30
			maxhealth=30
			see_in_dark=8
			New()
				src.flick_state="fire4"
				src.weapon_sound=SOUND_AUG_1
				fire_speed=1
				gun_power=52
				clip=120
				mclip=120
				..()
				spawn()src.NPC()
			Death()
				del(src)
				icon_state="corpse4"
				density=0
			NPC()
				if(GameOver)return
				if(!src.target)
					for(var/mob/Z in oview(rand(4,6),src))
						if(!Z.alignment)continue
						src.target=Z
						break
					if(src.target)
						spawn(src.fire_speed)src.NPC()
						return
					else
						spawn(rand(10,30))src.NPC()
						return
				else
					var/targetdist=get_dist(src.target,src)
					if(targetdist>6)
						src.target=null
						spawn(rand(3,6))src.NPC()
						return
					else if(targetdist<=6)
						if(src.clip>0)
							src.clip--
							src.dir=get_dir(src,src.target)
							orange(7,src)<<sound(src.weapon_sound,0,0,0,volume=(src.weapon_volume-master_vol))
							flick(src.flick_state,src)
							var/chancehit=100
							chancehit-=(10*targetdist)
							chancehit-=rand(1,8)
							if(prob(chancehit))
								//new/obj/blood_effects/splatter(src.target.loc)
								var/damage=src.gun_power
								if(prob(BLOODDROPRATE) && length(src.target.loc.overlays) < MAX_BLOOD)src.target.loc.overlays += new/obj/blood_effects/blood
								src.target.health-=damage
								if(src.target.health<=0)
									death_zombie(null,src.target)
							spawn(rand(1,2))src.NPC()
							return
						else
							sleep(50)
							src.clip=mclip
							spawn()src.NPC()
							return
					else
						spawn(rand(7,12))src.NPC()
						return

		Swat_Turret
			name="S.W.A.T. Turret"
			icon='turret.dmi'
			icon_state="normal1"
			health=15
			maxhealth=15
			density=1
			see_in_dark=6
			New()
				src.flick_state="fire1"
				src.weapon_sound=SOUND_AUG_1
				fire_speed=1
				gun_power=40
				clip=100
				mclip=100
				src.density=1
				..()
				spawn()src.NPC()
			Death()
				del(src)
				icon_state="corpse1"
				density=0
			NPC()
				density=1
				if(GameOver)return
				if(!src.target)
					for(var/mob/Z in oview(rand(4,6),src))
						if(!Z.alignment)continue
						src.target=Z
						break
					if(src.target)
						spawn(src.fire_speed)src.NPC()
						return
					else
						spawn(1)src.NPC()
						return
				else
					var/targetdist=get_dist(src.target,src)
					if(targetdist>6)
						src.target=null
						spawn(rand(3,6))src.NPC()
						return
					else if(targetdist<=6)
						if(src.clip>0)
							src.clip--
							src.dir=get_dir(src,src.target)
							orange(7,src)<<sound(src.weapon_sound,0,0,0,volume=(src.weapon_volume-master_vol))
							flick(src.flick_state,src)
							var/chancehit=100
							chancehit-=(10*targetdist)
							chancehit-=rand(1,8)
							if(prob(chancehit))
								//new/obj/blood_effects/splatter(src.target.loc)
								var/damage=src.gun_power
								if(prob(BLOODDROPRATE) && length(src.target.loc.overlays) < MAX_BLOOD)src.target.loc.overlays += new/obj/blood_effects/blood
								src.target.health-=damage
								if(src.target.health<=0)
									death_zombie(null,src.target)
							spawn(rand(1,2))src.NPC()
							return
						else
							sleep(20)
							src.clip=mclip
							src.density=1
							spawn()src.NPC()
							return
					else
						spawn(rand(7,12))src.NPC()
						density=1
						return
		Army_QS_Turret
			name="Army Second Gun Turret(Activated)"
			icon='Items/Icons/QS_Items.dmi'
			icon_state="normal2"
			health=30
			maxhealth=30
			density=1
			see_in_dark=6
			New()
				src.flick_state="fire2"
				src.weapon_sound=SOUND_AUG_1
				fire_speed=1
				gun_power=60
				clip=400
				ammo=8000
				mclip=400
				src.density=1
				..()
				spawn()src.NPC()
			Death()
				del(src)
				icon_state="corpse2"
				density=0
			DblClick()
				var/mob/player/client/M=usr
				if(acommander==usr)
					M<<"You stop commanding this unit"
					acommander=""
					M.acommand--
					acommanded=0
					src.New()
				else if(acommanded==1)
					M<<"This unit is already under controll!"
					return
				else if(M.acommand<=2)
					acommander=usr
					acommanded=1
					M<<"You command this Turret. All kills from it shall be yours!"
					M.acommand++
					src.New()
				else
					M<<"You can only command 2!"
					return
			NPC()
				density=1
				if(GameOver)return
				if(!src.target)
					for(var/mob/Z in oview(rand(4,6),src))
						if(!Z.alignment)continue
						src.target=Z
						break
					if(src.target)
						spawn(src.fire_speed)src.NPC()
						return
					else
						spawn(1)src.NPC()
						return
				else
					var/targetdist=get_dist(src.target,src)
					if(targetdist>6)
						src.target=null
						spawn(rand(3,6))src.NPC()
						return
					else if(targetdist<=6)
						if(src.clip>0)
							src.clip--
							src.dir=get_dir(src,src.target)
							orange(7,src)<<sound(src.weapon_sound,0,0,0,volume=(src.weapon_volume-master_vol))
							flick(src.flick_state,src)
							var/chancehit=100
							chancehit-=(10*targetdist)
							chancehit-=rand(1,8)
							if(prob(chancehit))
								//new/obj/blood_effects/splatter(src.target.loc)
								var/damage=src.gun_power
								if(prob(BLOODDROPRATE) && length(src.target.loc.overlays) < MAX_BLOOD)src.target.loc.overlays += new/obj/blood_effects/blood
								src.target.health-=damage
								if(src.target.health<=0)
									death_zombie(null,src.target)
									if(acommander)
										var/mob/player/client/M=acommander
										if(!M.gamein)return
										M.kills += 1
							spawn(rand(1,2))src.NPC()
							return
						else
							sleep(20)
							if(!src.ammo)return
							if(src.mclip>src.ammo)
								src.clip = src.ammo
								src.ammo = 0
							else
								src.ammo -=src.mclip
								src.clip = src.mclip
							src.density=1
							spawn()src.NPC()
							return
					else
						spawn(rand(7,12))src.NPC()
						density=1
						return
		BH_QS_Turret
			name="Black Hand Second Gun Turret(Activated)"
			icon='Items/Icons/QS_Items.dmi'
			icon_state="normal3"
			health=80
			maxhealth=80
			density=1
			see_in_dark=6
			New()
				src.flick_state="fire3"
				src.weapon_sound=SOUND_AUG_1
				fire_speed=0.1
				gun_power=100
				ammo = 3000
				clip=800
				mclip=800
				src.density=1
				..()
				spawn()src.NPC()
			DblClick()
				var/mob/player/client/M=usr
				if(bhcommander==usr)
					M<<"You stop commanding this unit"
					bhcommander=""
					M.bhcommand--
					bhcommanded=0
				else if(bhcommanded==1)
					M<<"This unit is already under controll!"
					return
				else if(M.bhcommand<=2)
					bhcommander=usr
					bhcommanded=1
					M<<"You command this Turret. All kills from it shall be yours!"
					M.bhcommand++
				else
					M<<"You can only command 2!"
					return
			Death()
				del(src)
				icon_state="corps3"
				density=0
			NPC()
				density=1
				if(GameOver)return
				if(!src.target)
					for(var/mob/Z in oview(rand(4,6),src))
						if(!Z.alignment)continue
						src.target=Z
						break
					if(src.target)
						spawn(src.fire_speed)src.NPC()
						return
					else
						spawn(1)src.NPC()
						return
				else
					var/targetdist=get_dist(src.target,src)
					if(targetdist>6)
						src.target=null
						spawn(rand(3,6))src.NPC()
						return
					else if(targetdist<=6)
						if(src.clip>0)
							src.clip--
							src.dir=get_dir(src,src.target)
							orange(7,src)<<sound(src.weapon_sound,0,0,0,volume=(src.weapon_volume-master_vol))
							flick(src.flick_state,src)
							var/chancehit=100
							chancehit-=(10*targetdist)
							chancehit-=rand(1,8)
							if(prob(chancehit))
								//new/obj/blood_effects/splatter(src.target.loc)
								var/damage=src.gun_power
								if(prob(BLOODDROPRATE) && length(src.target.loc.overlays) < MAX_BLOOD)src.target.loc.overlays += new/obj/blood_effects/blood
								src.target.health-=damage
								if(src.target.health<=0)
									death_zombie(null,src.target)
									if(bhcommander)
										var/mob/player/client/M=bhcommander
										if(!M.gamein)return
										M.kills += 1
							spawn(rand(1,2))src.NPC()
							return
						else
							sleep(20)
							if(!src.ammo)return
							if(src.mclip>src.ammo)
								src.clip = src.ammo
								src.ammo = 0
							else
								src.ammo -=src.mclip
								src.clip = src.mclip
							src.density=1
							spawn()src.NPC()
							return
					else
						spawn(rand(7,12))src.NPC()
						density=1
						return
		Army_Turret
			name="Army Turret"
			icon='turret.dmi'
			icon_state="normal2"
			health=30
			maxhealth=30
			density=1
			see_in_dark=6
			New()
				src.flick_state="fire2"
				src.weapon_sound=SOUND_AUG_1
				fire_speed=1
				gun_power=50
				clip=200
				mclip=200
				src.density=1
				..()
				spawn()src.NPC()
			Death()
				del(src)
				icon_state="corpse2"
				density=0
			NPC()
				density=1
				if(GameOver)return
				if(!src.target)
					for(var/mob/Z in oview(rand(4,6),src))
						if(!Z.alignment)continue
						src.target=Z
						break
					if(src.target)
						spawn(src.fire_speed)src.NPC()
						return
					else
						spawn(1)src.NPC()
						return
				else
					var/targetdist=get_dist(src.target,src)
					if(targetdist>6)
						src.target=null
						spawn(rand(3,6))src.NPC()
						return
					else if(targetdist<=6)
						if(src.clip>0)
							src.clip--
							src.dir=get_dir(src,src.target)
							orange(7,src)<<sound(src.weapon_sound,0,0,0,volume=(src.weapon_volume-master_vol))
							flick(src.flick_state,src)
							var/chancehit=100
							chancehit-=(10*targetdist)
							chancehit-=rand(1,8)
							if(prob(chancehit))
								//new/obj/blood_effects/splatter(src.target.loc)
								var/damage=src.gun_power
								if(prob(BLOODDROPRATE) && length(src.target.loc.overlays) < MAX_BLOOD)src.target.loc.overlays += new/obj/blood_effects/blood
								src.target.health-=damage
								if(src.target.health<=0)
									death_zombie(null,src.target)
							spawn(rand(1,2))src.NPC()
							return
						else
							sleep(20)
							src.clip=mclip
							src.density=1
							spawn()src.NPC()
							return
					else
						spawn(rand(7,12))src.NPC()
						density=1
						return
	Mob
		proc/walk_here(atom/T)
			var/step_num=get_dist(src,T)
			spawn()
				for(var/i=1,i<=step_num,i++)
					step_to(src,T)
					sleep(10)
		Death()
			range(src)<<sound(SOUND_NPCDEATH,volume=(rand(70,100)-master_vol))
			del(src)
		UCM
			DblClick()
				var/mob/player/client/M=usr
				if(commander=="[M]")
					M<<"You stop commanding this unit"
					walk(src,0)
					commander=""
					M.command--
					commanded=0
				else if(commanded==1)
					M<<"This unit is already under controll!"
					return
				else if(M.command<=5)
					commander="[M]"
					commanded=1
					M<<"You command this NPC"
					walk_to(src,M,get_dist(src,M),10)
					M.command++
				else
					M<<"You can only command 6!"
					return

			name="U.C.M"
			icon='icons/Normal/Hunk.dmi'
			icon_state="normal"
			health=16
			maxhealth=16
			see_in_dark=4
			New()
				switch(rand(1,3))
					if(1){src.gun='Guns/Fireing_States/G3SG1.dmi';src.flick_state="ShootingMachineH";src.weapon_sound=SOUND_G3SG1_1;fire_speed=1;gun_power=29;clip=20;mclip=20;mammo=500}
					if(2){src.gun='Guns/Fireing_States/AUG.dmi';src.flick_state="ShootingMachineH";src.weapon_sound=SOUND_AUG_1;fire_speed=1;gun_power=27;clip=36;mclip=36;mammo=500}
					if(3){src.gun='Guns/Fireing_States/CustomH.dmi';src.flick_state="ShootingHandgun";src.weapon_sound=SOUND_M92F_CUSTOM_HANDGUN_FIRE;fire_speed=7;gun_power=40;clip=12;mclip=12;mammo=140}
				src.overlays+=gun
				src.grenade=3
				src.ammo=(src.mammo-rand(20,40))
				..()
				spawn()src.NPC()
		Army
			DblClick()
				var/mob/player/client/M=usr
				if(commander=="[M]")
					M<<"You stop commanding this unit"
					walk(src,0)
					commander=""
					M.command--
					commanded=0
				else if(commanded==1)
					M<<"This unit is already under controll!"
					return
				else if(M.command<=5)
					commander="[M]"
					commanded=1
					M<<"You command this NPC"
					walk_to(src,M,get_dist(src,M),10)
					M.command++
				else
					M<<"You can only command 6!"
					return
			name="Army Soldier"
			icon='icons/Custom/Army2.dmi'
			icon_state="normal"
			health=20
			maxhealth=20
			see_in_dark=4
			New()
				switch(rand(1,3))
					if(1){src.gun='Guns/Fireing_States/G3SG1.dmi';src.flick_state="ShootingMachineH";src.weapon_sound=SOUND_G3SG1_1;fire_speed=1;gun_power=29;clip=20;mclip=20;mammo=500}
					if(2){src.gun='Guns/Fireing_States/AUG.dmi';src.flick_state="ShootingMachineH";src.weapon_sound=SOUND_AUG_1;fire_speed=1;gun_power=27;clip=36;mclip=36;mammo=500}
					if(3){src.gun='Guns/Fireing_States/CustomH.dmi';src.flick_state="ShootingHandgun";src.weapon_sound=SOUND_M92F_CUSTOM_HANDGUN_FIRE;fire_speed=7;gun_power=40;clip=12;mclip=12;mammo=140}
				src.overlays+=gun
				src.grenade=3
				src.ammo=(src.mammo-rand(20,40))
				..()
				spawn()src.NPC()
		Army_Winter
			DblClick()
				var/mob/player/client/M=usr
				if(commander=="[M]")
					M<<"You stop commanding this unit"
					walk(src,0)
					commander=""
					M.command--
					commanded=0
				else if(commanded==1)
					M<<"This unit is already under controll!"
					return
				else if(M.command<=5)
					commander="[M]"
					commanded=1
					M<<"You command this NPC"
					walk_to(src,M,get_dist(src,M),10)
					M.command++
				else
					M<<"You can only command 6!"
					return

			name="Winter Army Soldier"
			icon='icons/Custom/ARMY Winter.dmi'
			icon_state="normal"
			health=20
			maxhealth=20
			see_in_dark=4
			New()
				switch(rand(1,3))
					if(1){src.gun='Guns/Fireing_States/G3SG1.dmi';src.flick_state="ShootingMachineH";src.weapon_sound=SOUND_G3SG1_1;fire_speed=1;gun_power=29;clip=20;mclip=20;mammo=500}
					if(2){src.gun='Guns/Fireing_States/AUG.dmi';src.flick_state="ShootingMachineH";src.weapon_sound=SOUND_AUG_1;fire_speed=1;gun_power=27;clip=36;mclip=36;mammo=500}
					if(3){src.gun='Guns/Fireing_States/CustomH.dmi';src.flick_state="ShootingHandgun";src.weapon_sound=SOUND_M92F_CUSTOM_HANDGUN_FIRE;fire_speed=7;gun_power=40;clip=12;mclip=12;mammo=140}
				src.overlays+=gun
				src.grenade=3
				src.ammo=(src.mammo-rand(20,40))
				..()
				spawn()src.NPC()

		Swat
			DblClick()
				var/mob/player/client/M=usr
				if(commander=="[M]")
					M<<"You stop commanding this unit"
					walk(src,0)
					commander=""
					M.command--
					commanded=0
				else if(commanded==1)
					M<<"This unit is already under controll!"
					return
				else if(M.command<=5)
					commander="[M]"
					commanded=1
					M<<"You command this NPC"
					walk_to(src,M,get_dist(src,M),10)
					M.command++
				else
					M<<"You can only command 6!"
					return

			name="S.W.A.T."
			icon='icons/Custom/Swat.dmi'
			icon_state="normal"
			health=20
			maxhealth=20
			see_in_dark=4
			New()
				switch(rand(1,3))
					if(1){src.gun='Guns/Fireing_States/G3SG1.dmi';src.flick_state="ShootingMachineH";src.weapon_sound=SOUND_G3SG1_1;fire_speed=1;gun_power=29;clip=20;mclip=20;mammo=500}
					if(2){src.gun='Guns/Fireing_States/AUG.dmi';src.flick_state="ShootingMachineH";src.weapon_sound=SOUND_AUG_1;fire_speed=1;gun_power=27;clip=36;mclip=36;mammo=500}
					if(3){src.gun='Guns/Fireing_States/CustomH.dmi';src.flick_state="ShootingHandgun";src.weapon_sound=SOUND_M92F_CUSTOM_HANDGUN_FIRE;fire_speed=7;gun_power=40;clip=12;mclip=12;mammo=140}
				src.overlays+=gun
				src.grenade=4
				src.ammo=(src.mammo-rand(20,40))
				..()
				spawn()src.NPC()
		SpecOps
			DblClick()
				var/mob/player/client/M=usr
				if(commander=="[M]")
					M<<"You stop commanding this unit"
					walk(src,0)
					commander=""
					M.command--
					commanded=0
				else if(commanded==1)
					M<<"This unit is already under controll!"
					return
				else if(M.command<=5)
					commander="[M]"
					commanded=1
					M<<"You command this NPC"
					walk_to(src,M,get_dist(src,M),10)
					M.command++
				else
					M<<"You can only command 6!"
					return
			name="Special Ops"
			icon='icons/Custom/SpecOps.dmi'
			icon_state="normal"
			health=25
			maxhealth=25
			see_in_dark=4
			New()
				switch(rand(1,3))
					if(1){src.gun='Guns/Fireing_States/G3SG1.dmi';src.flick_state="ShootingMachineH";src.weapon_sound=SOUND_G3SG1_1;fire_speed=1;gun_power=29;clip=20;mclip=20;mammo=500}
					if(2){src.gun='Guns/Fireing_States/AUG.dmi';src.flick_state="ShootingMachineH";src.weapon_sound=SOUND_AUG_1;fire_speed=1;gun_power=27;clip=36;mclip=36;mammo=500}
					if(3){src.gun='Guns/Fireing_States/CustomH.dmi';src.flick_state="ShootingHandgun";src.weapon_sound=SOUND_M92F_CUSTOM_HANDGUN_FIRE;fire_speed=7;gun_power=40;clip=12;mclip=12;mammo=140}
				src.overlays+=gun
				src.grenade=6
				src.ammo=(src.mammo-rand(20,40))
				..()
				spawn()src.NPC()

		RPD_male
			DblClick()
				var/mob/player/client/M=usr
				if(commander=="[M]")
					M<<"You stop commanding this unit"
					walk(src,0)
					commander=""
					M.command--
					commanded=0
				else if(commanded==1)
					M<<"This unit is already under controll!"
					return
				else if(M.command<=5)
					commander="[M]"
					commanded=1
					M<<"You command this NPC"
					walk_to(src,M,get_dist(src,M),10)
					M.command++
				else
					M<<"You can only command 6!"
					return

			name="RPD Male"
			icon='icons/Normal/RPD male.dmi'
			icon_state="normal"
			health=16
			maxhealth=16
			see_in_dark=4
			New()
				switch(rand(1,3))
					if(1){src.gun='Guns/Fireing_States/G3SG1.dmi';src.flick_state="ShootingMachineH";src.weapon_sound=SOUND_G3SG1_1;fire_speed=1;gun_power=29;clip=20;mclip=20;mammo=500}
					if(2){src.gun='Guns/Fireing_States/AUG.dmi';src.flick_state="ShootingMachineH";src.weapon_sound=SOUND_AUG_1;fire_speed=1;gun_power=27;clip=36;mclip=36;mammo=500}
					if(3){src.gun='Guns/Fireing_States/CustomH.dmi';src.flick_state="ShootingHandgun";src.weapon_sound=SOUND_M92F_CUSTOM_HANDGUN_FIRE;fire_speed=7;gun_power=40;clip=12;mclip=12;mammo=140}
				src.overlays+=gun
				src.grenade=3
				src.ammo=(src.mammo-rand(20,40))
				..()
				spawn()src.NPC()
		RPD_female
			DblClick()
				var/mob/player/client/M=usr
				if(commander=="[M]")
					M<<"You stop commanding this unit"
					walk(src,0)
					commander=""
					M.command--
					commanded=0
				else if(commanded==1)
					M<<"This unit is already under controll!"
					return
				else if(M.command<=5)
					commander="[M]"
					commanded=1
					M<<"You command this NPC"
					walk_to(src,M,get_dist(src,M),10)
					M.command++
				else
					M<<"You can only command 6!"
					return

			name="RPD Female"
			icon='icons/Normal/RPD female.dmi'
			icon_state="normal"
			health=16
			maxhealth=16
			see_in_dark=4
			New()
				switch(rand(1,3))
					if(1){src.gun='Guns/Fireing_States/G3SG1.dmi';src.flick_state="ShootingMachineH";src.weapon_sound=SOUND_G3SG1_1;fire_speed=1;gun_power=29;clip=20;mclip=20;mammo=500}
					if(2){src.gun='Guns/Fireing_States/AUG.dmi';src.flick_state="ShootingMachineH";src.weapon_sound=SOUND_AUG_1;fire_speed=1;gun_power=27;clip=36;mclip=36;mammo=500}
					if(3){src.gun='Guns/Fireing_States/CustomH.dmi';src.flick_state="ShootingHandgun";src.weapon_sound=SOUND_M92F_CUSTOM_HANDGUN_FIRE;fire_speed=7;gun_power=40;clip=12;mclip=12;mammo=140}
				src.overlays+=gun
				src.grenade=3
				src.ammo=(src.mammo-rand(20,40))
				..()
				spawn()src.NPC()
		Scientist1
			DblClick()
				var/mob/player/client/M=usr
				if(commander=="[M]")
					M<<"You stop commanding this unit"
					walk(src,0)
					commander=""
					M.command--
					commanded=0
				else if(commanded==1)
					M<<"This unit is already under controll!"
					return
				else if(M.command<=5)
					commander="[M]"
					commanded=1
					M<<"You command this NPC"
					walk_to(src,M,get_dist(src,M),10)
					M.command++
				else
					M<<"You can only command 6!"
					return
			name="Scientist"
			icon='icons/Custom/Scientists (1).dmi'
			icon_state="normal"
			health=16
			maxhealth=16
			see_in_dark=4
			New()
				src.gun='Guns/Fireing_States/CustomH.dmi';src.flick_state="ShootingHandgun";src.weapon_sound=SOUND_M92F_CUSTOM_HANDGUN_FIRE;fire_speed=7;gun_power=50;clip=12;mclip=12;mammo=140
				src.overlays+=gun
				src.grenade=2
				src.ammo=(src.mammo-rand(20,40))
				..()
				spawn()src.NPC()
		Scientist2
			DblClick()
				var/mob/player/client/M=usr
				if(commander=="[M]")
					M<<"You stop commanding this unit"
					walk(src,0)
					commander=""
					M.command--
					commanded=0
				else if(commanded==1)
					M<<"This unit is already under controll!"
					return
				else if(M.command<=5)
					commander="[M]"
					commanded=1
					M<<"You command this NPC"
					walk_to(src,M,get_dist(src,M),10)
					M.command++
				else
					M<<"You can only command 6!"
					return
			name="Scientist"
			icon='icons/Custom/Scientists (2).dmi'
			icon_state="normal"
			health=16
			maxhealth=16
			see_in_dark=4
			New()
				src.gun='Guns/Fireing_States/CustomH.dmi';src.flick_state="ShootingHandgun";src.weapon_sound=SOUND_M92F_CUSTOM_HANDGUN_FIRE;fire_speed=7;gun_power=50;clip=12;mclip=12;mammo=140
				src.overlays+=gun
				src.grenade=2
				src.ammo=(src.mammo-rand(20,40))
				..()
				spawn()src.NPC()
		Scientist3
			DblClick()
				var/mob/player/client/M=usr
				if(commander=="[M]")
					M<<"You stop commanding this unit"
					walk(src,0)
					commander=""
					M.command--
					commanded=0
				else if(commanded==1)
					M<<"This unit is already under controll!"
					return
				else if(M.command<=5)
					commander="[M]"
					commanded=1
					M<<"You command this NPC"
					walk_to(src,M,get_dist(src,M),10)
					M.command++
				else
					M<<"You can only command 6!"
					return
			name="Scientist"
			icon='icons/Custom/Scientists (3).dmi'
			icon_state="normal"
			health=16
			maxhealth=16
			see_in_dark=4
			New()
				src.gun='Guns/Fireing_States/CustomH.dmi';src.flick_state="ShootingHandgun";src.weapon_sound=SOUND_M92F_CUSTOM_HANDGUN_FIRE;fire_speed=7;gun_power=50;clip=12;mclip=12;mammo=140
				src.overlays+=gun
				src.grenade=2
				src.ammo=(src.mammo-rand(20,40))
				..()
				spawn()src.NPC()
		BlackHand
			DblClick()
				var/mob/player/client/M=usr
				if(commander=="[M]")
					M<<"You stop commanding this unit"
					walk(src,0)
					commander=""
					M.command--
					commanded=0
				else if(commanded==1)
					M<<"This unit is already under controll!"
					return
				else if(M.command<=5)
					commander="[M]"
					commanded=1
					M<<"You command this NPC"
					walk_to(src,M,get_dist(src,M),30)
					M.command++
				else
					M<<"You can only command 6!"
					return
			name="Black Hand Heavy Artillery"
			icon='icons/Custom/Black Hand.dmi'
			icon_state="normal"
			health=10
			maxhealth=10
			see_in_dark=4
			New()
				src.gun='Guns/Fireing_States/Mini.dmi';src.flick_state="ShootingShotgun";src.weapon_sound=SOUND_M4A1_FIRE;fire_speed=1;gun_power=100;clip=500;mclip=500;mammo=5000
				src.overlays+=gun
				src.grenade=5
				src.ammo=(src.mammo-rand(20,40))
				..()
				spawn()src.NPC()
		BlackHandSpecial
			DblClick()
				var/mob/player/client/M=usr
				if(commander=="[M]")
					M<<"You stop commanding this unit"
					walk(src,0)
					commander=""
					M.command--
					commanded=0
				else if(commanded==1)
					M<<"This unit is already under controll!"
					return
				else if(M.command<=5)
					commander="[M]"
					commanded=1
					M<<"You command this NPC"
					walk_to(src,M,get_dist(src,M),10)
					M.command++
				else
					M<<"You can only command 6!"
					return
			name="Black Hand Special Weapons"
			icon='icons/Custom/Black Hand.dmi'
			icon_state="normal"
			health=30
			maxhealth=30
			see_in_dark=4
			New()
				switch(rand(1,3))
					if(1){src.gun='Guns/Fireing_States/Nod Gun.dmi';src.flick_state="ShootingMachineH";src.weapon_sound=SOUND_M4A1_FIRE;fire_speed=1;gun_power=150;clip=100;mclip=100;mammo=1000}
					if(2){src.gun='Guns/Fireing_States/shin.dmi';src.flick_state="ShootingMachineH";src.weapon_sound=SOUND_M4A1_FIRE;fire_speed=1;gun_power=150;clip=100;mclip=100;mammo=1000}
				src.overlays+=gun
				src.grenade=5
				src.ammo=(src.mammo-rand(20,40))
				..()
				spawn()src.NPC()

		Clone_Trooper
			DblClick()
				var/mob/player/client/M=usr
				if(commander=="[M]")
					M<<"You stop commanding this unit"
					walk(src,0)
					commander=""
					M.command--
					commanded=0
				else if(commanded==1)
					M<<"This unit is already under controll!"
					return
				else if(M.command<=5)
					commander="[M]"
					commanded=1
					M<<"You command this NPC"
					walk_to(src,M,get_dist(src,M),10)
					M.command++
				else
					M<<"You can only command 6!"
					return
			name="Clone Trooper"
			icon='icons/Custom/Clone_Trooper.dmi'
			icon_state="normal"
			health=18
			maxhealth=18
			see_in_dark=4
			New()
				switch(rand(1,3))
					if(1){src.gun='Guns/Fireing_States/G3SG1.dmi';src.flick_state="ShootingMachineH";src.weapon_sound=SOUND_G3SG1_1;fire_speed=1;gun_power=32;clip=20;mclip=20;mammo=1200}
					if(2){src.gun='Guns/Fireing_States/AUG.dmi';src.flick_state="ShootingMachineH";src.weapon_sound=SOUND_AUG_1;fire_speed=1;gun_power=32;clip=36;mclip=36;mammo=1200}
					if(3){src.gun='Guns/Fireing_States/CustomH.dmi';src.flick_state="ShootingHandgun";src.weapon_sound=SOUND_M92F_CUSTOM_HANDGUN_FIRE;fire_speed=7;gun_power=40;clip=12;mclip=12;mammo=600}
				src.overlays+=gun
				src.grenade=3
				src.ammo=(src.mammo-rand(20,40))
				..()
				spawn()src.NPC()
		Clone_Commando
			DblClick()
				var/mob/player/client/M=usr
				if(commander=="[M]")
					M<<"You stop commanding this unit"
					walk(src,0)
					commander=""
					M.command--
					commanded=0
				else if(commanded==1)
					M<<"This unit is already under controll!"
					return
				else if(M.command<=5)
					commander="[M]"
					commanded=1
					M<<"You command this NPC"
					walk_to(src,M,get_dist(src,M),10)
					M.command++
				else
					M<<"You can only command 6!"
					return
			name="Clone Commando"
			icon='icons/Custom/Clone_Commando.dmi'
			icon_state="normal"
			health=24
			maxhealth=24
			see_in_dark=4
			New()
				switch(rand(1,3))
					if(1){src.gun='Guns/Fireing_States/G3SG1.dmi';src.flick_state="ShootingMachineH";src.weapon_sound=SOUND_G3SG1_1;fire_speed=1;gun_power=32;clip=20;mclip=20;mammo=1200}
					if(2){src.gun='Guns/Fireing_States/AUG.dmi';src.flick_state="ShootingMachineH";src.weapon_sound=SOUND_AUG_1;fire_speed=1;gun_power=32;clip=36;mclip=36;mammo=1200}
					if(3){src.gun='Guns/Fireing_States/CustomH.dmi';src.flick_state="ShootingHandgun";src.weapon_sound=SOUND_M92F_CUSTOM_HANDGUN_FIRE;fire_speed=7;gun_power=40;clip=12;mclip=12;mammo=600}
				src.overlays+=gun
				src.grenade=3
				src.ammo=(src.mammo-rand(20,40))
				..()
				spawn()src.NPC()

		NPC()
			if(GameOver)return
			if(!src.target)
				for(var/mob/Z in oview(6,src))
					if(!Z.alignment)continue
					src.target=Z
					break
				if(src.target)
					spawn(src.fire_speed)src.NPC()
					return
				else
					spawn(rand(5,15))src.NPC()
					return
			else
				var/targetdist=get_dist(src.target,src)
				if(targetdist>7)
					src.target=null
					spawn(rand(2,4))src.NPC()
					return
				if(targetdist>=2&&!td&&prob(2)&&!src.throwed&&src.grenade)
					src.throwed=1
					spawn(40)src.throwed=0
					var/turf/T=get_step(src,get_dir(src,src.target))
					if(T&&T.density){spawn(10)src.NPC();return}
					if(!src.target){spawn(2)src.NPC();return}
					var/turf/gtarget=src.target.loc
					src.grenade--
					var/obj/effects/Grenade/X = new(src.loc,src.dir,null,null)
					src.dir=get_dir(src,src.target)
					spawn()steploop(X,gtarget,2)
					spawn((targetdist*2))if(X)X.density=0
					spawn((targetdist*4))
						if(prob(30))range(7,src)<<sound(SOUND_BLOW,volume=(100-master_vol))
						if(X)X.BlowUp(2,675)
					spawn(10)src.NPC()
					return
				else if(targetdist<2)
					src.dir=get_dir(src,src.target)
					new/obj/effects/slash(get_step(src,src.dir),src.dir)
					oview(7,src)<<sound(SOUND_SLASH,0,0,0,volume=(60-master_vol))
					src.target.health-=rand(20,28)
					if(src.target.health<=0)death_zombie(null,src.target)
					if(src.health<(src.maxhealth/3))step_away(src,src.target)
					spawn(4)src.NPC()
					return
				else if(targetdist<=7)
					if(src.clip>0)
						if(targetdist<=3&&src.health<(src.maxhealth/2))
							if(!src.need_backup)
								src.need_backup = 1
								range(7,src)<<sound(SOUND_INEEDBACKUP,volume=(rand(60,80)-master_vol))
							step_away(src,src.target)
							sleep(4)
						src.clip--
						src.dir=get_dir(src,src.target)
						orange(7,src)<<sound(src.weapon_sound,0,0,0,volume=(src.weapon_volume-master_vol))
						flick(src.flick_state,src)
						var/chancehit=100
						chancehit-=(10*targetdist)
						chancehit-=rand(1,8)
						if(prob(chancehit))
							//new/obj/blood_effects/splatter(src.target.loc)
							var/damage=src.gun_power
							if(prob(BLOODDROPRATE) && length(src.target.loc.overlays) < MAX_BLOOD)src.target.loc.overlays += new/obj/blood_effects/blood
							src.target.health-=damage
							if(src.target.health<=0)
								if(prob(10))range(7,src)<<sound(SOUND_ENEMYDOWN,volume=(100-master_vol))
								death_zombie(null,src.target)
						var/time=src.fire_speed
						if(prob(30))time++
						spawn(time)src.NPC()
						return
					else if(src.ammo<0)
						spawn(10)src.NPC()
						return
					else
						if(prob(20))range(7,src)<<sound(SOUND_COVERME,volume=(100-master_vol))
						sleep(rand(20,40))
						var/takeammo=src.mclip
						if(takeammo>src.ammo)takeammo=src.ammo
						src.ammo-=takeammo
						src.clip+=takeammo
						view(7,src)<<sound(SOUND_BOLT_REL,0,volume=(80-master_vol))
						spawn(10)src.NPC()
						return
				else
					spawn(rand(5,10))src.NPC()
					return
