obj/Pickup
	Guns


// ======== Teir 1 ===========
// ======== Teir 2 ===========
// ======== Teir 3 ===========

		Avenger
			name = "Avenger Missle Launcher"
			icon_state = "Avenger"
			icon = 'Guns/Icons/Launchers.dmi'
			clip = 5
			mclip = 5
			maxammo = MAXROCKETAMMO
			firerate = 12
			fire_power = 0
			reload_time = 38
			reload_sound = SOUND_RELOADING_2
			fire_sound = SOUND_ROCKET
			ammo_path = /obj/Pickup/Items/Ammo_Rocket
			ammo_type = "Rocket Ammo"
			flicker = "ShootingHandgun"
			overlay_add = 'Guns/Fireing_States/RocketLauncher.dmi'
			sound_wav = 65
			at = 7
			cost = 39000
			is_discard=0
			can_upgrade_fp = 0
			gunpower_level = 1
			upgrade_mc = list(1=7)
			upgrade_fr = list(1=5)
			upgrade_fp = list(1=0)
			upgrade_rs = list(1=30)
			projectile = /obj/projectiles/avenger

// ======== Teir 4 ===========

		Rocket_Launcher
			name = "Rocket Launcher"
			icon_state = "RL"
			icon = 'Guns/Icons/Launchers.dmi'
			clip = 2
			mclip = 2
			maxammo = MAXROCKETAMMO
			firerate = 12
			fire_power = 0
			reload_time = 38
			reload_sound = SOUND_RELOADING_2
			fire_sound = SOUND_ROCKET
			ammo_path = /obj/Pickup/Items/Ammo_Rocket
			ammo_type = "Rocket Ammo"
			flicker = "ShootingHandgun"
			overlay_add = 'Guns/Fireing_States/RocketLauncher.dmi'
			sound_wav = 65
			at = 7
			cost = 14000
			is_discard=0
			can_upgrade_fr = 0
			can_upgrade_rs = 0
			can_upgrade_fp = 0
			can_upgrade_cc = 0
			clip_level = 1
			firerate_level = 1
			gunpower_level = 1
			reloadtime_level = 1
			upgrade_mc = list(1=2)
			upgrade_fr = list(1=12)
			upgrade_fp = list(1=0)
			upgrade_rs = list(1=38)
			projectile = /obj/projectiles/rocket

		Grenade_Launcher
			name = "Grenade Launcher"
			icon_state = "Grenade Launcher"
			icon = 'Guns/Icons/Launchers.dmi'
			clip = 2
			mclip = 6
			maxammo = MAXNADEAMMO
			firerate = 16
			fire_power = 0
			reload_time = 28
			reload_sound = SOUND_RELOADING_2
			fire_sound = SOUND_GLAUNCHER
			ammo_path = null
			ammo_type = "Explosive/Acid/Flame/Freeze Rounds"
			flicker = "ShootingShotgun"
			overlay_add = 'Guns/Fireing_States/GrenadeLauncher.dmi'
			sound_wav = 65
			at = 7
			cost = 8200
			is_discard=0
			can_upgrade_fr = 0
			can_upgrade_rs = 0
			can_upgrade_fp = 0
			can_upgrade_cc = 0
			clip_level = 1
			firerate_level = 1
			gunpower_level = 1
			reloadtime_level = 1
			upgrade_mc = list(1=6)
			upgrade_fr = list(1=16)
			upgrade_fp = list(1=0)
			upgrade_rs = list(1=28)
			projectile = /obj/projectiles/explosive
			grenade_launcher = 1
			verb
				Change_Ammo()
					set category = "Commands"
					set src in usr
					set category = null
					var/mob/player/client/M=usr
					if(!(src in M))return
					if(!M.gamein||M.reloading||GameOver)return
					src.identify_ammo(M,1)
					var/list/sammo = list("Flame\[[M.ammo["Flame Rounds"]]]" = /obj/projectiles/flame, "Acid\[[M.ammo["Acid Rounds"]]]" = /obj/projectiles/acid, "Freeze\[[M.ammo["Freeze Rounds"]]]" = /obj/projectiles/freeze, "Explosive\[[M.ammo["Explosive Rounds"]]]" = /obj/projectiles/explosive)
					var/answer = sammo[input(M,"Change ammo type to?","Change Ammo")as null|anything in sammo]
					if(!answer||!(src in M))return
					src.projectile = answer
					src.identify_ammo(M)
					if(M.weapon && M.weapon == src)
						src.suffix="[src.clip]/[src.mclip]"

		B_O_W
			name = "B.O.W."
			icon = 'Guns/Icons/Launchers.dmi'
			icon_state = "BOW"
			clip=8
			mclip=8
			maxammo = MAXROCKETAMMO
			maxammo = MAXNADEAMMO
			firerate = 8
			fire_power = 0
			reload_time = 14.5
			reload_sound = SOUND_RELOADING_2
			fire_sound = SOUND_GLAUNCHER
			ammo_path = null
			ammo_type = "Rocket Ammo/Acid/Flame/Freeze Rounds"
			flicker = "ShootingMachineH"
			overlay_add = 'Guns/Fireing_States/Bow.dmi'
			sound_wav = 65
			at = 7
			cost = 15000
			is_discard = 0
			can_upgrade_fr = 0
			can_upgrade_rs = 0
			can_upgrade_fp = 0
			can_upgrade_cc = 0
			clip_level = 1
			firerate_level = 1
			gunpower_level = 1
			reloadtime_level = 1
			upgrade_mc = list(1=8)
			upgrade_fr = list(1=8)
			upgrade_fp = list(1=0)
			upgrade_rs = list(1=14.5)
			projectile = /obj/projectiles/rocket
			projectile = /obj/projectiles/explosive
			grenade_launcher = 1
			verb
				Change_Ammo()
					set category = "Commands"
					set src in usr
					set category = null
					var/mob/player/client/M=usr
					if(!(src in M))return
					if(!M.gamein||M.reloading||GameOver)return
					src.identify_ammo(M,1)
					var/list/sammo = list("Rocket Ammo\[[M.ammo["Rocket Ammo"]]]" = /obj/projectiles/rocket, "Acid\[[M.ammo["Acid Rounds"]]]" = /obj/projectiles/acid, "Freeze\[[M.ammo["Freeze Rounds"]]]" = /obj/projectiles/freeze, "Flame\[[M.ammo["Flame Rounds"]]]" = /obj/projectiles/flame)
					var/answer = sammo[input(M,"Change ammo type to?","Change Ammo")as null|anything in sammo]
					if(!answer||!(src in M))return
					src.projectile = answer
					src.identify_ammo(M)
					if(M.weapon && M.weapon == src)
						src.suffix="[src.clip]/[src.mclip]"