obj/Pickup
	Guns

// ======== Teir X ===========

		Thousand_Sons
			name = "Thousand Sons Bolter"
			icon_state = "TS"
			icon = 'Guns/Icons/Others.dmi'
			clip = 1.#INF
			mclip = 1.#INF
			maxammo = MAXROCKETAMMO
			firerate = 5
			fire_power = 0
			reload_time = 1
			reload_sound = SOUND_RELOADING_2
			fire_sound = SOUND_ROCKET
			ammo_path = null
			ammo_type = "Rocket Ammo"
			flicker = "ShootingShotgun"
			overlay_add = 'Guns/Fireing_States/ThousandSun.dmi'
			sound_wav = 65
			at = 7
			cost = 5000000
			is_discard=0
			can_upgrade_fr = 0
			can_upgrade_rs = 0
			can_upgrade_fp = 0
			can_upgrade_cc = 0
			clip_level = 1
			firerate_level = 1
			gunpower_level = 1
			reloadtime_level = 1
			upgrade_mc = list(1=1.#INF)
			upgrade_fr = list(1=5)
			upgrade_fp = list(1=0)
			upgrade_rs = list(1=1)
			projectile = /obj/projectiles/sun

		Lightning_Strike
			name = "Lightning Strike Bolter"
			icon_state = "LS"
			icon = 'Guns/Icons/Others.dmi'
			clip = 1.#INF
			mclip = 1.#INF
			maxammo = MAXROCKETAMMO
			firerate = 5
			fire_power = 0
			reload_time = 1
			reload_sound = SOUND_RELOADING_2
			fire_sound = SOUND_ROCKET
			ammo_path = null
			ammo_type = "Rocket Ammo"
			flicker = "ShootingShotgun"
			overlay_add = 'Guns/Fireing_States/chaos.dmi'
			sound_wav = 65
			at = 7
			cost = 5000000
			is_discard=0
			can_upgrade_fr = 0
			can_upgrade_rs = 0
			can_upgrade_fp = 0
			can_upgrade_cc = 0
			clip_level = 1
			firerate_level = 1
			gunpower_level = 1
			reloadtime_level = 1
			upgrade_mc = list(1=1.#INF)
			upgrade_fr = list(1=5)
			upgrade_fp = list(1=0)
			upgrade_rs = list(1=1)
			projectile = /obj/projectiles/lightning2

// ======== Teir 1 ===========

		SB
			name = "SwitchBlade"
			icon = 'Guns/Icons/Others.dmi'
			icon_state = "switchbladea"
			clip=200
			mclip=200
			maxammo = MAXSBMAMMO
			fire_power=75
			reload_time=23
			firerate=1
			reload_sound=SOUND_UMP45_BOLTPULL
			fire_sound=SOUND_M4A1_FIRE
			ammo_type="SwitchBlade Machinegun Ammo"
			flicker="ShootingMachineL"
			overlay_add='Guns/Fireing_States/MP5.dmi'
			sound_wav=55
			at=5
			cost=275000
			upgrade_mc=list(1=200)
			upgrade_fp=list(1=125)
			upgrade_rs=list(1=18,2=14,3=5)
			upgrade_fr=list(1=1)
			can_upgrade_fr = 0
			can_upgrade_cc = 0
			clip_level=1
			mode="AR"
			firerate_level=1
			ammo_path=/obj/Pickup/Items/Ammo_SB_Machinegun
			verb
				Change_Mode()
					set category = "Commands"
					set src in usr
					set category = null
					var/mob/player/client/M=usr
					if(!(src in M))return
					if(!M.gamein||M.reloading||GameOver)return
					var/list/ammol = list("Assault Rifle", "Rocket Launcher")
					var/answer = input(M,"Change ammo type to?","Change Ammo")as null|anything in ammol
					if(answer)
						if(answer == "Assault Rifle")
							if(src.mode == "AR")
								M << "The weapon is already in Assault Rifle Mode!"
								return
							else
								M << "Transforming gun mode now.... Please Wait."
								src.icon_state="trans2"
								sleep(28)
								src.icon_state="switchbladea"
								src.ammo_path=/obj/Pickup/Items/Ammo_SB_Machinegun
								src.ammo_type="SwitchBlade Machinegun Ammo"
								src.firerate=1
								src.clip = 200
								src.mclip = 200
								src.projectile = null
								src.maxammo = MAXSBMAMMO
								src.identify_ammo(M)
								flicker="ShootingMachineL"
								overlay_add='Guns/Fireing_States/MP5.dmi'
								src.mode = "AR"
								fire_sound=SOUND_M4A1_FIRE
								src.identify_ammo(M)

						if(answer == "Rocket Launcher")
							if(src.mode == "RL")
								M << "The weapon is already in Rocket Launcher Mode!"
								return
							else
								M << "Transforming gun mode now.... Please Wait."
								src.icon_state="trans1"
								sleep(28)
								src.icon_state="switchblader"
								M << "Transformation Complete!"
								src.ammo_path=/obj/Pickup/Items/Ammo_SB_Rockets
								src.ammo_type="SwitchBlade Rocket Ammo"
								src.firerate=10
								src.clip = 50
								src.mclip = 50
								src.projectile = /obj/projectiles/switchblade1
								src.maxammo = MAXSBRAMMO
								src.identify_ammo(M)
								flicker="ShootingHandgun"
								overlay_add='Guns/Fireing_States/RocketLauncher.dmi'
								src.mode = "RL"
								fire_sound=SOUND_ROCKET
								src.identify_ammo(M)
		Minigun
			name = "Vulcan Minigun"
			icon = 'Guns/Icons/Others.dmi'
			icon_state = "mini"
			clip=500
			mclip=500
			maxammo = MAXVMAMMO
			firerate=0.5
			fire_power=150
			reload_time=200
			reload_sound=SOUND_UMP45_BOLTPULL
			fire_sound=SOUND_MINIGUN
			ammo_type="Vulcan Minigun Rounds"
			flicker="ShootingShotgun"
			overlay_add='Guns/Fireing_States/Mini.dmi'
			sound_wav=55
			at=5
			cost=225000
			clip_level_cost=25000
			upgrade_mc=list(1=1000)
			upgrade_fp=list(1=175)
			upgrade_rs=list(1=120)
			upgrade_fr=list(1=1)
			can_upgrade_fr = 0
			can_upgrade_rs = 0
			firerate_level=1
			ammo_path=/obj/Pickup/Items/Ammo_Vulcan
			verb
				PropUp()
					set category = "Commands"
					set src in usr
					set category = null
					if(GameOn == 0)return
					if(GameOn == 1)return
					var/mob/player/client/M=usr
					if(!(src in M))return
					if(!M.gamein||M.reloading||GameOver)return
					if(src.propped==1)return
					src.propped=1
					M.frozen=1
					src.fire_power+=100
					src.reload_time-=70
					src.firerate=0.01
					src.mclip+=1000
				Unprop()
					set category = "Commands"
					set src in usr
					set category = null
					if(GameOn == 0)return
					if(GameOn == 1)return
					var/mob/player/client/M=usr
					if(!(src in M))return
					if(!M.gamein||M.reloading||GameOver)return
					if(src.propped==0)return
					src.propped=0
					M.frozen=0
					src.fire_power-=100
					src.reload_time+=80
					src.firerate=1
					src.mclip-=1000

// ======== Teir 2 ===========

		BlackLightningShot
			name = "Black Lightning Shot"
			icon_state = "lightning2"
			icon = 'Guns/Icons/Others.dmi'
			clip = 40
			mclip = 40
			maxammo = MAXBLAMMO
			firerate = 15
			fire_power = 0
			reload_time = 25
			reload_sound = SOUND_RELOADING_2
			fire_sound = SOUND_GLAUNCHER
			ammo_type = "Black Lightning Shot Ammo"
			flicker = "ShootingMachineH"
			overlay_add = 'Guns/Fireing_States/blacklightning.dmi'
			sound_wav = 65
			at = 7
			spread2 = 1
			cost = 150000
			is_discard = 0
			reloadtime_level_cost=10000
			can_upgrade_fp = 0
			upgrade_mc = list(1=75)
			upgrade_fr = list(1=5)
			upgrade_fp = list(1=0)
			upgrade_rs = list(1=8)
			projectile = /obj/projectiles/lightning3
			ammo_path=/obj/Pickup/Items/Ammo_Lightning2

// ======== Teir 3 ===========

		LightningShot
			name = "Red Lightning Shot"
			icon_state = "lightning1"
			icon = 'Guns/Icons/Others.dmi'
			clip = 20
			mclip = 20
			maxammo = MAXLAMMO
			firerate = 20
			fire_power = 0
			reload_time = 50
			reload_sound = SOUND_RELOADING_2
			fire_sound = SOUND_GLAUNCHER
			ammo_type = "Lightning Shot Ammo"
			flicker = "ShootingMachineH"
			overlay_add = 'Guns/Fireing_States/redlightning.dmi'
			sound_wav = 65
			at = 7
			spread2 = 1
			cost = 45000
			is_discard = 0
			reloadtime_level_cost=10000
			can_upgrade_fp = 0
			gunpower_level = 1
			upgrade_mc = list(1=60)
			upgrade_fr = list(1=5)
			upgrade_fp = list(1=0)
			upgrade_rs = list(1=40)
			projectile = /obj/projectiles/lightning
			ammo_path=/obj/Pickup/Items/Ammo_Lightning

// ======== Teir 4 ===========

		FlameThrower
			name = "FlameThrower"
			icon_state = "Flame"
			icon = 'Guns/Icons/Others.dmi'
			clip = 40
			mclip = 40
			maxammo = MAXFLAMEAMMO
			firerate = 15
			fire_power = 0
			reload_time = 50
			reload_sound = SOUND_RELOADING_2
			fire_sound = SOUND_GLAUNCHER
			ammo_type = "Flame Charge"
			flicker = "ShootingMachineH"
			overlay_add = 'Guns/Fireing_States/Flamer.dmi'
			sound_wav = 65
			at = 7
			spread2 = 1
			cost = 20000
			is_discard = 0
			reloadtime_level_cost=10000
			can_upgrade_fp = 0
			upgrade_mc = list(1=60)
			upgrade_fr = list(1=5)
			upgrade_fp = list(1=0)
			upgrade_rs = list(1=10)
			projectile = /obj/projectiles/flame
			ammo_path=/obj/Pickup/Items/Ammo_Flame_Charge
			grenade_launcher = 1

		Freeze_Ray
			name = "Freeze Ray"
			icon_state = "Ice"
			icon = 'Guns/Icons/Others.dmi'
			clip = 40
			mclip = 40
			maxammo = MAXICEAMMO
			firerate = 15
			fire_power = 0
			reload_time = 50
			reload_sound = SOUND_RELOADING_2
			fire_sound = SOUND_GLAUNCHER
			ammo_type = "Freeze Charge"
			flicker = "ShootingMachineH"
			overlay_add = 'Guns/Fireing_States/Flamer.dmi'
			sound_wav = 65
			at = 7
			spread2 = 1
			cost = 20000
			is_discard = 0
			reloadtime_level_cost=10000
			can_upgrade_fp = 0
			upgrade_mc = list(1=60)
			upgrade_fr = list(1=5)
			upgrade_fp = list(1=0)
			upgrade_rs = list(1=10)
			projectile = /obj/projectiles/freeze
			ammo_path=/obj/Pickup/Items/Ammo_Freeze_Charge
			grenade_launcher = 1

		Acid_Shooter
			name = "Acid Shooter"
			icon_state = "Acid"
			icon = 'Guns/Icons/Others.dmi'
			clip = 40
			mclip = 40
			maxammo = MAXACIDAMMO
			firerate = 15
			fire_power = 0
			reload_time = 50
			reload_sound = SOUND_RELOADING_2
			fire_sound = SOUND_GLAUNCHER
			ammo_type = "Acid Charge"
			flicker = "ShootingMachineH"
			overlay_add = 'Guns/Fireing_States/Flamer.dmi'
			sound_wav = 65
			at = 7
			spread2 = 1
			cost = 20000
			is_discard = 0
			reloadtime_level_cost=10000
			can_upgrade_fp = 0
			can_upgrade_fp = 0
			upgrade_mc = list(1=60)
			upgrade_fr = list(1=5)
			upgrade_fp = list(1=0)
			upgrade_rs = list(1=10)
			projectile = /obj/projectiles/acid
			ammo_path=/obj/Pickup/Items/Ammo_Acid_Charge
			grenade_launcher = 1
